
package org.netbeans.modules.asm.x86.syntax;

import org.netbeans.modules.asm.model.lang.syntax.AsmToken;

public class X86Token implements AsmToken<X86TokenId> {
    
    final private X86TokenId id;
    final private int start, end;
    final private String text;
    
    public X86Token(X86TokenId id, String text, int start, int end) {
        this.id = id;
        this.text = text;
        this.start = start;
        this.end = end;
    } 
    
    public X86TokenId getId() {
        return id;        
    }

    public String getText() {
        return text;
    }

    public int getStartOffset() {
        return start;
    }

    public int getEndOffset() {
        return end;
    }               
}
