
package org.netbeans.jsstubsgenerator.core.mdn;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import org.netbeans.jsstubsgenerator.stub.GeneratorUtils;
import org.netbeans.jsstubsgenerator.stub.Origin;
import org.netbeans.jsstubsgenerator.stub.StubObject;
import org.netbeans.jsstubsgenerator.stub.Type;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class ArgumentsGenerator {

    private static final String ARGUMENTS = "Arguments";

    public static void generateArguments(Map<String, StubObject> allStubs) throws IOException {
        // general definition
        StubObject arguments = new StubObject(Origin.CORE, ARGUMENTS, StubObject.GLOBAL);
        arguments.setPrune(false);
        arguments.setType(Type.OBJECT);

        // properties definition
        String[][] properties = new String[][]{
            {"length", "Number", ""},
            {"callee", "Function", ""},
            {"caller", "Function", ""},
        };
        List<StubObject> generatedInstanceProperties = generateInstanceProperties(properties);
        for (StubObject instanceProperty : generatedInstanceProperties) {
            arguments.putAttribute(instanceProperty);
        }

        allStubs.put(ARGUMENTS, arguments);
    }

    private static List<StubObject> generateInstanceProperties(String[][] properties) {
        List<StubObject> propertyStubs = GeneratorUtils.generateProperties(Origin.CORE, properties, ARGUMENTS, false);
        return propertyStubs;
    }

}
