/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.dom;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import org.netbeans.jsstubsgenerator.stub.GeneratorUtils;
import org.netbeans.jsstubsgenerator.stub.Origin;
import org.netbeans.jsstubsgenerator.stub.Parameter;
import org.netbeans.jsstubsgenerator.stub.StubObject;
import org.netbeans.jsstubsgenerator.stub.Type;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class CryptoInstanceGenerator {

    public static void generate(Map<String, StubObject> allStubs) throws IOException {
        // general definition
        StubObject cryptoObject = new StubObject(Origin.DOM, "Crypto", StubObject.GLOBAL);
        cryptoObject.setPrune(true);
        cryptoObject.setType(Type.OBJECT);
        cryptoObject.setSummary("The crypto API allows web pages access to certain cryptographic related services. These services are a balance between the functionality web pages need, and the requirement to protect users from malicious web sites.");

        // methods definition
        String[][] methods = new String[][]{
            {"getRandomValues", "Array", "This methods lets you get cryptographically random values."},
        };
        List<StubObject> generatedMethods = generateMethods(methods);
        for (StubObject instanceMethod : generatedMethods) {
            cryptoObject.putAttribute(instanceMethod);
        }

        allStubs.put("Crypto", cryptoObject);
    }

    private static List<StubObject> generateMethods(String[][] methods) {
        List<StubObject> methodStubs = GeneratorUtils.generateMethods(methods, "Crypto", true);
        for (StubObject method : methodStubs) {
            if ("getRandomValues".equals(method.getName())) {
                method.setSyntax("window.crypto.getRandomValues(typedArray);");
                method.addParameter(new Parameter("typedArray", "Array", "Integer-based TypedArray. All elements in the array are going to be overridden with random numbers."));
            }
        }
        return methodStubs;
    }

}
