
package org.netbeans.jsstubsgenerator.dom;

import org.netbeans.jsstubsgenerator.stub.StubObject;

/**
 * Update stubs where couldn't be automatically parsed and fixed.
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class CustomUpdater {

    public static void updateHTMLElementObject(StubObject element) {
        assert element != null;

        // issue #215867 - Signature files are missing element.style attribute
        element.putImplements("ElementCSSInlineStyle");
    }
    
    public static void updateElementObject(StubObject element) {
        assert element != null;

        // issue #221163 - Code completion on HTMLElement incomplete
        element.putImplements("ElementTraversal");
    }

    public static void updateDocumentObject(StubObject element) {
        assert element != null;

        // issue #221163 - Code completion on HTMLElement incomplete
        element.putImplements("DocumentTraversal");
    }

}
