/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.print;

import org.netbeans.jsstubsgenerator.stub.StubObject;

/**
 * Prints small structures in the jsDoc documentation.
 *
 * @author marfous
 */
public class JsFunction extends JsConstruct {

    boolean innerAttribute;

    public JsFunction(StubObject stubObject, int nestedLevel, boolean innerAttribute) {
        super(stubObject, nestedLevel);
        this.innerAttribute = innerAttribute;
    }

    private void begin(String functionName) {
        if (innerAttribute) {
            if (stubObject.isStatic()) {
                jsBuilder.append(stubObject.getParent() + "." + functionName + " = function(", false);
            } else {
                jsBuilder.append(stubObject.getParent() + ".prototype." + functionName + " = function(", false);
            }
        } else {
            jsBuilder.append("function " + functionName + "(", false);
        }
        if (stubObject.getSyntax() != null && !"".equals(stubObject.getSyntax())) {
            Utils.fulfilArguments(jsBuilder, stubObject);
        }
        jsBuilder.append(") {};");
    }

    public String print() {
        appendDoc(new DocSummary(stubObject, nestedLevel));
        begin(stubObject.getName());
        return jsBuilder.toString();
    }

}
