/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2009 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.test.uihandler.selenium;

import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

/**
 *
 * @author Jindrich Sedek
 */
public class DetailPageTest extends SeleniumTestBase {

    @Override
    public void setUp() throws Exception {
        super.setUp();
        URL url = new URL(URL + "/analytics/detail.do?id=1");
        URLConnection connection = url.openConnection();
        connection.setReadTimeout(60000);
        InputStream is = connection.getInputStream();
        is.close();
    }

    public void testDetailPage() throws Exception {
        selenium.open("/analytics/detail.do?id=1");
	assertTrue(selenium.isTextPresent("Report #1"));
	selenium.click("link=1");
	Thread.sleep(2000);//wait for popup window
	assertTrue(selenium.isTextPresent("java.lang.NullPointerException: TESTING"));
	Thread.sleep(2000);//wait for stacktrace load
	assertTrue(selenium.isTextPresent("at throw1.Throw.performAction(Throw.java:10)"));
	selenium.click("link=#1");
	waitForPageToLoad();
	assertTrue(selenium.isTextPresent("Exception #1"));
	assertTrue(selenium.isTextPresent("java.lang.NullPointerException: TESTING"));
	selenium.click("link=1");
	waitForPageToLoad();
	selenium.click("link=7");
	Thread.sleep(2000);//wait for popup window
	assertTrue(selenium.isTextPresent("java.lang.NullPointerException: TESTING"));
	selenium.click("link=#7");
	waitForPageToLoad();
	assertTrue(selenium.isTextPresent("Exception #7"));
	selenium.click("link=1");
	waitForPageToLoad();
	assertTrue(selenium.isTextPresent("Report #1"));    }
}
