<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.util.Map"%>
<%@taglib uri="/WEB-INF/statistics.tld" prefix="ui"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%> 

<c:set var="path" value='/ <a href="../index.jsp">Analytics</a> / Graph / Versioning Commands '/>
<%@include file="/WEB-INF/jspf/header.jspf" %>
<ui:useStatistic name="VersioningCommand"/>

    <div class="f-page-cell bg-sky" >
        <h2>How often users run version control commands in external tools instead using the IDE support?</h2>
        <p>
            These statistics try to answer the question. They compare how often commands updating
            local sources are run in an external tool in compare to the ones started from the IDE,
            the total time spent in both kinds of commands and how many source modifications that 
            could trigger the scanning in the IDE they produce.
        </p>
        <%@include file="restrictQuery.jspf" %>
    </div>

    <% 
        Map countLast = (Map)pageContext.getAttribute("lastVersioningCommandCount");
        Map countUser = (Map)pageContext.getAttribute("userVersioningCommandCount");
        Map countAll = (Map)pageContext.getAttribute("globalVersioningCommandCount");
        Map timeLast = (Map)pageContext.getAttribute("lastVersioningCommandTime");
        Map timeUser = (Map)pageContext.getAttribute("userVersioningCommandTime");
        Map timeAll = (Map)pageContext.getAttribute("globalVersioningCommandTime");
        Map modificationsLast = (Map)pageContext.getAttribute("lastVersioningCommandModifications");
        Map modificationsUser = (Map)pageContext.getAttribute("userVersioningCommandModifications");
        Map modificationsAll = (Map)pageContext.getAttribute("globalVersioningCommandModifications");
    %>
    
    <% if (countLast != null && !countLast.isEmpty()) {%>
    <h3 class="b-bottom-dashed b-top f-page-cell">Your latest session</h3>
    <p><% out.println(countLast.get("External")); %> external commands were run,
        took <% out.println(timeLast.get("External")); %>s in total and modified overall 
        <% out.println(modificationsLast.get("External")); %> files.<br/>
       <% out.println(countLast.get("Internal")); %> commands were run from the IDE,
        took <% out.println(timeLast.get("Internal")); %>s in total and modified overall 
        <% out.println(modificationsLast.get("Internal")); %> files.</p>
    <ui:pie
       collection="lastVersioningCommandCount"
       category="key"
       value="value"
       title="Ratio of invoked commands from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="lastVersioningCommandTime"
       category="key"
       value="value"
       title="Time spent by commands run from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="lastVersioningCommandModifications"
       category="key"
       value="value"
       title="Ratio of file modifications done by commands started from the IDE and externally"
       resolution="600x200"
       />
    <% }%>
    
    <% if (countUser != null && !countUser.isEmpty()) { %>
    <h3 class="b-bottom-dashed b-top f-page-cell">Your all sessions</h3>
    <p><% out.println(countUser.get("External")); %> external commands were run,
        took <% out.println(timeUser.get("External")); %>s in total and modified overall 
        <% out.println(modificationsUser.get("External")); %> files.<br/>
       <% out.println(countUser.get("Internal")); %> commands were run from the IDE,
        took <% out.println(timeUser.get("Internal")); %>s in total and modified overall 
        <% out.println(modificationsUser.get("Internal")); %> files.</p>
    <ui:pie
       collection="userVersioningCommandCount"
       category="key"
       value="value"
       title="Ratio of invoked commands from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="userVersioningCommandTime"
       category="key"
       value="value"
       title="Time spent by commands run from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="userVersioningCommandModifications"
       category="key"
       value="value"
       title="Ratio of file modifications done by commands started from the IDE and externally"
       resolution="600x200"
       />
    <% }%>
    
    <% if (countAll != null && !countAll.isEmpty()) { %>
    <h3 class="b-bottom-dashed b-top f-page-cell">Overall statistics for all users</h3>
    <p><% out.println(countAll.get("External")); %> external commands were run,
        took <% out.println(timeAll.get("External")); %>s in total and modified overall 
        <% out.println(modificationsAll.get("External")); %> files.<br/>
       <% out.println(countAll.get("Internal")); %> commands were run from the IDE,
        took <% out.println(timeAll.get("Internal")); %>s in total and modified overall 
        <% out.println(modificationsAll.get("Internal")); %> files.</p>
    <ui:pie
       collection="globalVersioningCommandCount"
       category="key"
       value="value"
       title="Ratio of invoked commands from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="globalVersioningCommandTime"
       category="key"
       value="value"
       title="Time spent by commands run from the IDE and externally"
       resolution="600x200"
       />
    <ui:pie
       collection="globalVersioningCommandModifications"
       category="key"
       value="value"
       title="Ratio of file modifications done by commands started from the IDE and externally"
       resolution="600x200"
       />
    <% }%>
<%@include file="/WEB-INF/jspf/footer.jspf" %> 
