/*
 * CustomerValidator.java
 *
 * Created on September 21, 2006, 2:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.examples.masterdetail.api;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;
import java.util.Arrays;
import org.openide.util.NbBundle;

/**
 *
 * @author Tim
 */
final class CustomerValidator implements VetoableChangeListener {
    
    public void vetoableChange(PropertyChangeEvent evt) throws PropertyVetoException {
        int ix = Arrays.asList(Customer.PROPS).indexOf (evt.getPropertyName());
        String error = null;
        switch (ix) {
            case 0 :
                error = validateCity( (String) evt.getNewValue() );
                break;
            case 1 :
                error = validateState( (String) evt.getNewValue() );
                break;
            case 2 :
                error = validateFirstName( (String) evt.getNewValue() );
                break;
            case 3 :
                error = validateLastName( (String) evt.getNewValue() );
                break;
            case 4 :
                error = validateAddress( (String) evt.getNewValue() );
                break;
            case 5 :
                error = validatePostalCode( (String) evt.getNewValue() );
                break;
            default : 
                throw new IllegalArgumentException (evt.getPropertyName());
        }
        if (error != null) {
            throw new PropertyVetoException (error, evt);
        }
    }

    private String validateCity(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        return result;
    }

    private String validateState(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        return result;
    }

    private String validateFirstName(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        return result;
    }

    private String validateLastName(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        return result;
    }

    private String validateAddress(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        return result;
    }

    private String validatePostalCode(String val) {
        String result = null;
        if ("".equals(val) || val == null) { 
            result = NbBundle.getMessage(CustomerValidator.class, 
                    "ERR_EMPTY_PROPERTY"); 
        }
        val = val.trim();
        char[] c = val.toCharArray();
        for (int i = 0; i < c.length; i++) {
            if (!Character.isDigit(c[i])) {
                return "Not a digit: '" + c[i] + "'";
            }
        }
        return result;
    }
}
