drop table modules;
drop table MODULE_RATING;
drop table MODULE_CATEGORY;
drop table authors;

CREATE TABLE MODULES
	(moduleid INT NOT NULL GENERATED by default AS IDENTITY,
	 name varchar(50),
         description varchar(500),
         tags varchar(500),
         category_id int,
         author_username varchar(50),
         projecthome_url varchar(100),
         license_type varchar(100),
         target_platform varchar(100),
         min_version varchar(10),
         max_version varchar(10),
         downloads BIGINT not null,
         date_added date,
         date_last_updated date,
         nbm_filename varchar(255),
         nbm_file BLOB (2G),
         image_filename varchar(255),
         image BLOB
         );

alter table MODULES add constraint MODULES_PK
  PRIMARY KEY (moduleid);


CREATE TABLE MODULE_RATING
(
  moduleid            int,
  rating              smallint,
  date_rated     date,
  author_username     varchar(50),
  comments            varchar(500)
);

CREATE TABLE MODULE_CATEGORY
(
  categoryid    int NOT NULL GENERATED by default AS IDENTITY,
  name  varchar(50),
  description  varchar(255)
);

CREATE TABLE authors
(
  username  varchar(50) NOT NULL,
  password varchar(100),
  fullname varchar(100),
  email_id varchar(100)
);
alter table AUTHORS add constraint AUTHORS_PK
  PRIMARY KEY (username);
insert into authors values (
'user1',
'password',
'User 1',
'david.botterill@sun.com'
);

insert into authors values (
'user2',
'password',
'User 2',
'david.botterill@sun.com'
);


insert into modules values (DEFAULT,
'TEST NAME 1',
'Module description<br>line 2',
'tag1',
1,
'user1',
'http://www.davidbotterill.com',
'GPL',
'all',
'5.0',
'5.5',
50,
CURRENT_DATE,
CURRENT_DATE,
'module1.nbm',
null,
'image1.png',
null);

insert into modules values (DEFAULT,
'TEST NAME 2',
'Module description<br>line 2',
'tag2',
1,
'user2',
'http://www.davidbotterill.com',
'GPL',
'all',
'5.0',
'5.5',
100,
CURRENT_DATE,
CURRENT_DATE,
'module2.nbm',
null,
'image2.png',
null);
insert into module_category values(DEFAULT,'J2EE','J2EE Plugins');
insert into module_category values(DEFAULT,'Modeling Tools','UML Modeling, Etc.');
insert into module_category values(DEFAULT,'Java Tools','Java Tools');
insert into module_category values(DEFAULT,'Editor','Editor');
insert into module_category values(DEFAULT,'Developing NetBeans','Developing NetBeans');
insert into module_category values(DEFAULT,'Test Tools','Test Tools');
insert into module_category values(DEFAULT,'GUI Tools','GUI Tools');
insert into module_category values(DEFAULT,'Database','Database');
insert into module_category values(DEFAULT,'Web','Web');
insert into module_category values(DEFAULT,'Remote Development','Remote Development');
insert into module_category values(DEFAULT,'Distributed Application Support','Distributed Application Support');
insert into module_category values(DEFAULT,'Profiling','Profiling');
insert into module_category values(DEFAULT,'J2ME','J2ME');
insert into module_category values(DEFAULT,'XML','XML');
insert into module_category values(DEFAULT,'C,C++,FORTRAN','C,C++,FORTRAN');
insert into module_category values(DEFAULT,'Scripting Languages','Scripting Languages');
insert into module_category values(DEFAULT,'Tools','Tools');
insert into module_category values(DEFAULT,'Version Control','Version Control');
insert into module_category values(DEFAULT,'Refactoring','Refactoring');
insert into module_rating values(1,3,CURRENT_DATE,'user1','Comments');
insert into module_rating values(1,2,CURRENT_DATE,'user2','Comments');
insert into module_rating values(2,3,CURRENT_DATE,'user1','Comments');
insert into module_rating values(2,2,CURRENT_DATE,'user2','Comments');