/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package pluginportal;

import com.sun.webui.jsf.model.UploadedFile;
import java.io.File;
import java.util.Date;
import org.netbeans.pluginportal.system.SystemFileUtils;

/**
 *
 * @author David Botterill
 */
public class FileUtils {
    
     public static String defaultImage="/resources/thumbnail_placeholder.png";
     
    /** Creates a new instance of FileUtils */
    public FileUtils() {
    }
    

    public static  String getImageFile(UploadedFile uploadedFile) throws Exception {
        String uploadedFileName = uploadedFile.getOriginalName();
        // Some browsers return complete path name, some don't
        // Make sure we only have the file name
        // First, try forward slash
        int index = uploadedFileName.lastIndexOf('/');
        String justFileName;
        if ( index >= 0) {
            justFileName = uploadedFileName.substring( index + 1 );
        } else {
            // Try backslash
            index = uploadedFileName.lastIndexOf('\\');
            if (index >= 0) {
                justFileName = uploadedFileName.substring( index + 1 );
            } else {
                // No forward or back slashes
                justFileName = uploadedFileName;
            }
        }
        /**
         * Make sure the filename doesn't contain any characters not supported by the file upload like
         * spaces and "(", ")".
         */
        justFileName = justFileName.replaceAll("\\p{Space}","_");
        justFileName = justFileName.replaceAll("\\(","_");
        justFileName = justFileName.replaceAll("\\)","_");
        
        /**
         * prepend a timestamp to make sure the filename is unique.
         */
        justFileName = (new Date()).getTime() + "_" + justFileName;
        
        
        String realPath = SystemFileUtils.getImageLocation();
        File returnFile = new File(realPath + File.separatorChar +
                justFileName);
        
        uploadedFile.write(returnFile);
        
        
        return justFileName;
    }
    
    public static String getNBMFile(UploadedFile uploadedFile) throws Exception {
        
        
        /**
         * Save the upload file to a file on the plugin portal site.
         */
        
        String uploadedFileName = uploadedFile.getOriginalName();
        // Some browsers return complete path name, some don't
        // Make sure we only have the file name
        // First, try forward slash
        int index = uploadedFileName.lastIndexOf('/');
        String justFileName;
        if ( index >= 0) {
            justFileName = uploadedFileName.substring( index + 1 );
        } else {
            // Try backslash
            index = uploadedFileName.lastIndexOf('\\');
            if (index >= 0) {
                justFileName = uploadedFileName.substring( index + 1 );
            } else {
                // No forward or back slashes
                justFileName = uploadedFileName;
            }
        }
        /**
         * Make sure the filename doesn't contain any characters not supported by the file upload like
         * spaces and "(", ")".
         */
        justFileName = justFileName.replaceAll("\\p{Space}","_");
        justFileName = justFileName.replaceAll("\\(","_");
        justFileName = justFileName.replaceAll("\\)","_");
        
        /**
         * prepend a timestamp to make sure the filename is unique.
         */
        justFileName = (new Date()).getTime() + "_" + justFileName;
        
        String realPath = SystemFileUtils.getNbmLocation();
        File returnFile = new File(realPath + File.separatorChar +
                justFileName);
        
        uploadedFile.write(returnFile);
        
        return justFileName;
    }
    
 
}
