/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.data.provider.impl.ObjectArrayDataProvider;
import com.sun.rave.web.ui.appbase.AbstractSessionBean;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.model.DefaultOptionsList;
import com.sun.webui.jsf.model.UploadedFile;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import javax.el.MethodExpression;
import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.netbeans.pluginportal.system.CategoryCount;
import org.netbeans.pluginportal.system.SystemFileUtils;
import org.netbeans.pluginportal.ui.CategoryCountComparator;
import org.netbeans.pluginportal.system.CategoryRange;
import org.netbeans.pluginportal.system.OtherCategory;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.PluginException;
import org.netbeans.pluginportal.system.Rating;

/**
 * <p>Session scope data bean for your application.  Create properties
 *  here to represent cached data that should be made available across
 *  multiple HTTP requests for an individual user.</p>
 *
 * <p>An instance of this class will be created for you automatically,
 * the first time your application evaluates a value binding expression
 * or method binding expression that references a managed bean using
 * this class.</p>
 *
 *@author David Botterill
 */
public class SessionBean1 extends AbstractSessionBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
        /*
        pluginDetailsDataProvider.setArray((java.lang.Object[])getValue("#{PluginListPage.pluginDetails}"));
        categoryPluginsDataProvider.setArray((java.lang.Object[])getValue("#{CategoryPage.categoryPlugins}"));
        commentDataProvider.setArray((java.lang.Object[])getValue("#{PluginDetailPage.pluginComments}"));
         */
        listTargetPlatformDefaultOptions.setOptions(new com.sun.webui.jsf.model.Option[] {new com.sun.webui.jsf.model.Option("Solaris", "Solaris"), new com.sun.webui.jsf.model.Option("Linux", "Linux"), new com.sun.webui.jsf.model.Option("Mac OS X", "Mac OS X"), new com.sun.webui.jsf.model.Option("Windows", "Windows")});
        listTargetPlatformDefaultOptions.setMultiple(true);
        listTargetPlatformDefaultOptions.setSelectedValue(new Object[] {});
    }
    
    private ObjectArrayDataProvider pluginDetailsDataProvider = new ObjectArrayDataProvider();
    
    public ObjectArrayDataProvider getPluginDetailsDataProvider() {
        return pluginDetailsDataProvider;
    }
    
    public void setPluginDetailsDataProvider(ObjectArrayDataProvider oadp) {
        this.pluginDetailsDataProvider = oadp;
    }
    
    private ObjectArrayDataProvider categoryPluginsDataProvider = new ObjectArrayDataProvider();
    
    public ObjectArrayDataProvider getCategoryPluginsDataProvider() {
        return categoryPluginsDataProvider;
    }
    
    public void setCategoryPluginsDataProvider(ObjectArrayDataProvider oadp) {
        this.categoryPluginsDataProvider = oadp;
    }
    
    private ObjectArrayDataProvider commentDataProvider = new ObjectArrayDataProvider();
    
    public ObjectArrayDataProvider getCommentDataProvider() {
        return commentDataProvider;
    }
    
    public void setCommentDataProvider(ObjectArrayDataProvider oadp) {
        this.commentDataProvider = oadp;
    }
    
    private String currentAvgRatingText = new String();
    
    public String getCurrentAvgRatingText() {
        if(null != getCurrentPlugin()) {
            currentAvgRatingText = "Rated by " + getCurrentPlugin().getRatings().size() + " users.";
        }
        return currentAvgRatingText;
    }
    
    public void setCurrentAvgRatingText(String s) {
        this.currentAvgRatingText = s;
    }
    
    private DefaultOptionsList listTargetPlatformDefaultOptions = new DefaultOptionsList();
    
    public DefaultOptionsList getListTargetPlatformDefaultOptions() {
        listTargetPlatformDefaultOptions.setMultiple(true);
        return listTargetPlatformDefaultOptions;
    }
    
    public void setListTargetPlatformDefaultOptions(DefaultOptionsList dol) {
        this.listTargetPlatformDefaultOptions = dol;
    }
    
    private String selectedDisplayCategory = new String();
    
    public String getSelectedDisplayCategory() {
        return selectedDisplayCategory;
    }
    
    public void setSelectedDisplayCategory(String s) {
        this.selectedDisplayCategory = s;
    }
    
    private String selectedDevelopedWith = new String();
    
    public String getSelectedDevelopedWith() {
        return selectedDevelopedWith;
    }
    
    public void setSelectedDevelopedWith(String s) {
        this.selectedDevelopedWith = s;
    }
    // </editor-fold>
    
    /**
     * <p>Construct a new session data bean instance.</p>
     */
    public SessionBean1() {
    }
    
    /**
     * <p>This method is called when this bean is initially added to
     * session scope.  Typically, this occurs as a result of evaluating
     * a value binding or method binding expression, which utilizes the
     * managed bean facility to instantiate this bean and store it into
     * session scope.</p>
     *
     * <p>You may customize this method to initialize and cache data values
     * or resources that are required for the lifetime of a particular
     * user session.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("SessionBean1 Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
    }
    
    /**
     * <p>This method is called when the session containing it is about to be
     * passivated.  Typically, this occurs in a distributed servlet container
     * when the session is about to be transferred to a different
     * container instance, after which the <code>activate()</code> method
     * will be called to indicate that the transfer is complete.</p>
     *
     * <p>You may customize this method to release references to session data
     * or resources that can not be serialized with the session itself.</p>
     */
    public void passivate() {
    }
    
    /**
     * <p>This method is called when the session containing it was
     * reactivated.</p>
     *
     * <p>You may customize this method to reacquire references to session
     * data or resources that could not be serialized with the
     * session itself.</p>
     */
    public void activate() {
    }
    
    /**
     * <p>This method is called when this bean is removed from
     * session scope.  Typically, this occurs as a result of
     * the session timing out or being terminated by the application.</p>
     *
     * <p>You may customize this method to clean up resources allocated
     * during the execution of the <code>init()</code> method, or
     * at any later time during the lifetime of the application.</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * Holds value of property currentCategoryName.
     */
    private String currentCategoryName;
    
    /**
     * Getter for property currentCategoryName.
     * @return Value of property currentCategoryName.
     */
    public String getCurrentCategoryName() {
        return this.currentCategoryName;
    }
    
    /**
     * Setter for property currentCategoryName.
     * @param currentCategoryName New value of property currentCategoryName.
     */
    public void setCurrentCategoryName(String currentCategoryName) {
        this.currentCategoryName = currentCategoryName;
    }
    
    /**
     * Holds value of property currentPluginId.
     */
    private Long currentPluginId;
    
    /**
     * Getter for property currentPluginId.
     * @return Value of property currentPluginId.
     */
    public Long getCurrentPluginId() {
        return this.currentPluginId;
    }
    
    /**
     * Setter for property currentPluginId.
     * @param currentPluginId New value of property currentPluginId.
     */
    public void setCurrentPluginId(Long currentPluginId) {
        this.currentPluginId = currentPluginId;
    }
    
    /**
     * Holds value of property currentUserId.
     */
    private String currentUserId;
    
    /**
     * Getter for property currentUserId.
     * @return Value of property currentUserId.
     */
    public String getCurrentUserId() {
        return this.currentUserId;
    }
    
    /**
     * Setter for property currentUserId.
     * @param currentUserId New value of property currentUserId.
     */
    public void setCurrentUserId(String currentUserId) {
        this.currentUserId = currentUserId;
    }
    /**
     * Getter for property loggedIn.
     * @return Value of property loggedIn.
     */
    public boolean isLoggedIn() {
        if(null == this.getCurrentUserId()) {
            return false;
        } else {
            return true;
        }
    }
    
    /**
     * Holds value of property authToken.
     */
    private String authToken;
    
    /**
     * Getter for property authToken.
     * @return Value of property authToken.
     */
    public String getAuthToken() {
        return this.authToken;
    }
    
    /**
     * Setter for property authToken.
     * @param authToken New value of property authToken.
     */
    public void setAuthToken(String authToken) {
        this.authToken = authToken;
    }
    
    /**
     * Holds value of property returnFromLoginPage.
     */
    private String returnFromLoginPage;
    
    /**
     * Getter for property returnFromLoginPage.
     * @return Value of property returnFromLoginPage.
     */
    public String getReturnFromLoginPage() {
        return this.returnFromLoginPage;
    }
    
    /**
     * Setter for property returnFromLoginPage.
     * @param returnFromLoginPage New value of property returnFromLoginPage.
     */
    public void setReturnFromLoginPage(String returnFromLoginPage) {
        this.returnFromLoginPage = returnFromLoginPage;
    }
    
    /**
     * Holds value of property currentNbmFileName.
     */
    private String currentNbmFileName;
    
    /**
     * Getter for property currentNbmFileName.
     * @return Value of property currentNbmFileName.
     */
    public String getCurrentNbmFileName() {
        return this.currentNbmFileName;
    }
    
    /**
     * Setter for property currentNbmFileName.
     * @param currentNbmFileName New value of property currentNbmFileName.
     */
    public void setCurrentNbmFileName(String currentNbmFileName) {
        this.currentNbmFileName = currentNbmFileName;
    }
    
    /**
     * Holds value of property currentNBMDD.
     */
    private org.netbeans.pluginportal.system.NBMDeploymentDescriptor currentNBMDD;
    
    /**
     * Getter for property currentNBMDD.
     * @return Value of property currentNBMDD.
     */
    public org.netbeans.pluginportal.system.NBMDeploymentDescriptor getCurrentNBMDD() {
        return this.currentNBMDD;
    }
    
    /**
     * Setter for property currentNBMDD.
     * @param currentNBMDD New value of property currentNBMDD.
     */
    public void setCurrentNBMDD(org.netbeans.pluginportal.system.NBMDeploymentDescriptor currentNBMDD) {
        this.currentNBMDD = currentNBMDD;
    }
    
    /**
     * Holds value of property loginText.
     */
    private String loginText;
    
    /**
     * Getter for property loggedOn.
     * @return Value of property loggedOn.
     */
    public String getLoginText() {
        if(isLoggedIn()) {
            setLoginText("Logoff");
        } else {
            setLoginText("Login");
        }
        return this.loginText;
    }
    
    /**
     * Setter for property loggedOn.
     * @param loggedOn New value of property loggedOn.
     */
    public void setLoginText(String loginText) {
        this.loginText = loginText;
    }
    
    /**
     * Holds value of property loggedinVisible.
     */
    private boolean loggedinVisible = false;
    
    /**
     * Getter for property loggedinVisible.
     * @return Value of property loggedinVisible.
     */
    public boolean isLoggedinVisible() {
        if(isLoggedIn()) {
            setLoggedinVisible(true);
        } else {
            setLoggedinVisible(false);
        }
        return this.loggedinVisible;
    }
    
    /**
     * Setter for property loggedinVisible.
     * @param loggedinVisible New value of property loggedinVisible.
     */
    public void setLoggedinVisible(boolean loggedinVisible) {
        this.loggedinVisible = loggedinVisible;
    }
    
    /**
     * Holds value of property loginSeparator.
     */
    private String loginSeparator;
    
    /**
     * Getter for property loginSeparator.
     * @return Value of property loginSeparator.
     */
    public String getLoginSeparator() {
        if(isLoggedIn()) {
            setLoginSeparator("|");
        } else {
            setLoginSeparator(" ");
        }
        return this.loginSeparator;
    }
    
    /**
     * Setter for property loginSeparator.
     * @param loginSeparator New value of property loginSeparator.
     */
    public void setLoginSeparator(String loginSeparator) {
        this.loginSeparator = loginSeparator;
    }
    
    /**
     * Holds value of property pluginsForText.
     */
    private String pluginsForText;
    
    /**
     * Getter for property pluginsForText.
     * @return Value of property pluginsForText.
     */
    public String getPluginsForText() {
        setPluginsForText("Plugins for: " + getCurrentUserId());
        return this.pluginsForText;
    }
    
    /**
     * Setter for property pluginsForText.
     * @param pluginsForText New value of property pluginsForText.
     */
    public void setPluginsForText(String pluginsForText) {
        this.pluginsForText = pluginsForText;
    }
    
    /**
     * Holds value of property showAllMode.
     */
    private boolean showAllMode = true;
    
    /**
     * Getter for property showAllMode.
     * @return Value of property showAllMode.
     */
    public boolean isShowAllMode() {
        return this.showAllMode;
    }
    
    /**
     * Setter for property showAllMode.
     * @param showAllMode New value of property showAllMode.
     */
    public void setShowAllMode(boolean showAllMode) {
        this.showAllMode = showAllMode;
    }
    
    /**
     * Holds value of property showLinkText.
     */
    private String showLinkText = "Stable";
    
    /**
     * Getter for property showLinkText.
     * @return Value of property showLinkText.
     */
    public String getShowLinkText() {
        return this.showLinkText;
    }
    
    /**
     * Setter for property showLinkText.
     * @param showLinkText New value of property showLinkText.
     */
    public void setShowLinkText(String showLinkText) {
        this.showLinkText = showLinkText;
    }
    
    /**
     * Holds value of property showTitle.
     */
    private String showTitle = "Show: All";
    
    /**
     * Getter for property showTitle.
     * @return Value of property showTitle.
     */
    public String getShowTitle() {
        return this.showTitle;
    }
    
    /**
     * Setter for property showTitle.
     * @param showTitle New value of property showTitle.
     */
    public void setShowTitle(String showTitle) {
        this.showTitle = showTitle;
    }
    
    /**
     * Holds value of property orderByTitle.
     */
    private String orderByTitle = "Order by: Name";
    
    /**
     * Getter for property orderByTitle.
     * @return Value of property orderByTitle.
     */
    public String getOrderByTitle() {
        return this.orderByTitle;
    }
    
    /**
     * Setter for property orderByTitle.
     * @param orderByTitle New value of property orderByTitle.
     */
    public void setOrderByTitle(String orderByTitle) {
        this.orderByTitle = orderByTitle;
    }
    
    /**
     * Holds value of property currentOrderBy.
     */
    private OrderBy currentOrderBy = OrderBy.NAME;
    
    /**
     * Getter for property currentOrderBy.
     * @return Value of property currentOrderBy.
     */
    public OrderBy getCurrentOrderBy() {
        return this.currentOrderBy;
    }
    
    /**
     * Setter for property currentOrderBy.
     * @param currentOrderBy New value of property currentOrderBy.
     */
    public void setCurrentOrderBy(OrderBy currentOrderBy) {
        this.currentOrderBy = currentOrderBy;
    }
    
    /**
     * Holds value of property orderByLinkText1.
     */
    private String orderByLinkText1;
    
    /**
     * Getter for property orderByLinkText1.
     * @return Value of property orderByLinkText1.
     */
    public String getOrderByLinkText1() {
        return this.orderByLinkText1;
    }
    
    /**
     * Setter for property orderByLinkText1.
     * @param orderByLinkText1 New value of property orderByLinkText1.
     */
    public void setOrderByLinkText1(String orderByLinkText1) {
        this.orderByLinkText1 = orderByLinkText1;
    }
    
    /**
     * Holds value of property orderByLinkText2.
     */
    private String orderByLinkText2;
    
    /**
     * Getter for property orderByLinkText2.
     * @return Value of property orderByLinkText2.
     */
    public String getOrderByLinkText2() {
        return this.orderByLinkText2;
    }
    
    /**
     * Setter for property orderByLinkText2.
     * @param orderByLinkText2 New value of property orderByLinkText2.
     */
    public void setOrderByLinkText2(String orderByLinkText2) {
        this.orderByLinkText2 = orderByLinkText2;
    }
    
    /**
     * Holds value of property currentPluginName.
     */
    private String currentPluginName;
    
    /**
     * Getter for property currentPluginName.
     * @return Value of property currentPluginName.
     */
    public String getCurrentPluginName() {
        return this.currentPluginName;
    }
    
    /**
     * Setter for property currentPluginName.
     * @param currentPluginName New value of property currentPluginName.
     */
    public void setCurrentPluginName(String currentPluginName) {
        this.currentPluginName = currentPluginName;
    }
    
    /**
     * Holds value of property currentPlugin.
     */
    private Plugin currentPlugin;
    
    /**
     * Getter for property currentPlugin.
     * @return Value of property currentPlugin.
     */
    public Plugin getCurrentPlugin() {
        return this.currentPlugin;
    }
    
    /**
     * Setter for property currentPlugin.
     * @param currentPlugin New value of property currentPlugin.
     */
    public void setCurrentPlugin(Plugin currentPlugin) {
        this.currentPlugin = currentPlugin;
        /**
         * If the average rating is null, there will be a half-star rating
         * so we need to set it to 0.
         */
        if(null != currentPlugin) {
            if(null == currentPlugin.getAverage_rating()) {
                currentPlugin.setAverage_rating(0.0);
            }
        }
    }
    
    /**
     * Holds value of property currentSearchCriteria.
     */
    private String currentSearchCriteria;
    
    /**
     * Getter for property currentSearchCriteria.
     * @return Value of property currentSearchCriteria.
     */
    public String getCurrentSearchCriteria() {
        return this.currentSearchCriteria;
    }
    
    /**
     * Setter for property currentSearchCriteria.
     * @param currentSearchCriteria New value of property currentSearchCriteria.
     */
    public void setCurrentSearchCriteria(String currentSearchCriteria) {
        this.currentSearchCriteria = currentSearchCriteria;
    }
    
    /**
     * Holds value of property currentPlugins.
     */
    private Plugin[] currentPlugins;
    
    /**
     * Getter for property currentPlugins.
     * @return Value of property currentPlugins.
     */
    public org.netbeans.pluginportal.system.Plugin[] getCurrentPlugins() {
        return this.currentPlugins;
    }
    
    /**
     * Setter for property currentPlugins.
     * @param currentPlugins New value of property currentPlugins.
     */
    public void setCurrentPlugins(org.netbeans.pluginportal.system.Plugin[] currentPlugins) {
        this.currentPlugins = currentPlugins;
    }
    
    /**
     * Holds value of property commentBoxVisible.
     */
    private boolean commentBoxVisible;
    
    /**
     * Getter for property commentBoxVisible.
     * @return Value of property commentBoxVisible.
     */
    public boolean isCommentBoxVisible() {
        return this.commentBoxVisible;
    }
    
    /**
     * Setter for property commentBoxVisible.
     * @param commentBoxVisible New value of property commentBoxVisible.
     */
    public void setCommentBoxVisible(boolean commentBoxVisible) {
        this.commentBoxVisible = commentBoxVisible;
    }
    
    /**
     * Holds value of property commentButtonVisible.
     */
    private boolean commentButtonVisible;
    
    /**
     * Getter for property commentButtonVisible.
     * @return Value of property commentButtonVisible.
     */
    public boolean isCommentButtonVisible() {
        return this.commentButtonVisible;
    }
    
    /**
     * Setter for property commentButtonVisible.
     * @param commentButtonVisible New value of property commentButtonVisible.
     */
    public void setCommentButtonVisible(boolean commentButtonVisible) {
        this.commentButtonVisible = commentButtonVisible;
    }
    
    /**
     * Holds value of property hideCommentLinkVisible.
     */
    private boolean hideCommentLinkVisible;
    
    /**
     * Getter for property hideCommentLinkVisible.
     * @return Value of property hideCommentLinkVisible.
     */
    public boolean isHideCommentLinkVisible() {
        return this.hideCommentLinkVisible;
    }
    
    /**
     * Setter for property hideCommentLinkVisible.
     * @param hideCommentLinkVisible New value of property hideCommentLinkVisible.
     */
    public void setHideCommentLinkVisible(boolean hideCommentLinkVisible) {
        this.hideCommentLinkVisible = hideCommentLinkVisible;
    }
    
    /**
     * Holds value of property currentRating.
     */
    private int currentRating=0;
    
    /**
     * Getter for property currentRating.
     * @return Value of property currentRating.
     */
    public int getCurrentRating() {
        /**
         * Get the rating for the current logged in user.  If the user is not logged in, the rating
         * component iwll be in average mode and the current average value will be used.
         */
        if(isLoggedIn()) {
            Rating rating = this.getApplicationBean1().getPluginSystem().getRatingForUser(getCurrentPlugin().getPluginid(),getCurrentUserId());
            if(null != rating && null != rating.getRating_level()) {
                currentRating = rating.getRating_level().intValue();
            }
        }
        return this.currentRating;
    }
    
    /**
     * Setter for property currentRating.
     * @param currentRating New value of property currentRating.
     */
    public void setCurrentRating(int currentRating) {
        Rating newRating = this.getApplicationBean1().getPluginSystem().createRating();
        newRating.setDate_rated(new Date());
        newRating.setRating_level(currentRating);
        newRating.setUserid(getCurrentUserId());
        try {
            Plugin modifiedPlugin = this.getApplicationBean1().getPluginSystem().addRating(getCurrentPlugin(),newRating,getAuthToken(),getCurrentUserId());
            setCurrentPlugin(modifiedPlugin);
        } catch (PluginException ex) {
            log("Error adding a rating! Exception=" + ex.getMessage());
            return;
        }
        this.currentRating = currentRating;
    }
    
    /**
     * Holds value of property myRatingPanelVisible.
     */
    private Boolean myRatingPanelVisible;
    
    /**
     * Getter for property myRatingPanelVisible.
     * @return Value of property myRatingPanelVisible.
     */
    public Boolean getMyRatingPanelVisible() {
        return this.myRatingPanelVisible;
    }
    
    /**
     * Setter for property myRatingPanelVisible.
     * @param myRatingPanelVisible New value of property myRatingPanelVisible.
     */
    public void setMyRatingPanelVisible(Boolean myRatingPanelVisible) {
        this.myRatingPanelVisible = myRatingPanelVisible;
    }
    
    /**
     * Holds value of property rateable.
     */
    private boolean rateable;
    
    /**
     * Getter for property rateable.
     * @return Value of property rateable.
     */
    public boolean isRateable() {
        if(isLoggedIn() &&
                null != getCurrentPlugin() &&
                null != getCurrentPlugin().getAuthor_userid() &&
                !getCurrentPlugin().getAuthor_userid().equals(getCurrentUserId())) {
            rateable=true;
        } else {
            rateable=false;
        }
        return this.rateable;
    }
    
    /**
     * Setter for property rateable.
     * @param rateable New value of property rateable.
     */
    public void setRateable(boolean rateable) {
        this.rateable = rateable;
    }
    
    /**
     * Holds value of property normalRatingText.
     */
    private String normalRatingText="Your Rating";
    
    /**
     * Getter for property normalRatingText.
     * @return Value of property normalRatingText.
     */
    public String getNormalRatingText() {
        return this.normalRatingText;
    }
    
    /**
     * Setter for property normalRatingText.
     * @param normalRatingText New value of property normalRatingText.
     */
    public void setNormalRatingText(String normalRatingText) {
        this.normalRatingText = normalRatingText;
    }
    
    
    /**
     * Holds value of property nbmFileSize.
     */
    private long nbmFileSize;
    
    /**
     * Getter for property nbmFileSize.
     * @return Value of property nbmFileSize.
     */
    public long getNbmFileSize() {
        return this.nbmFileSize;
    }
    
    /**
     * Setter for property nbmFileSize.
     * @param nbmFileSize New value of property nbmFileSize.
     */
    public void setNbmFileSize(long nbmFileSize) {
        this.nbmFileSize = nbmFileSize;
    }
    
    /**
     * Holds value of property categoryInCloudView.
     */
    private boolean categoryInCloudView=true;
    
    /**
     * Getter for property categoryInCloudView.
     * @return Value of property categoryInCloudView.
     */
    public boolean isCategoryInCloudView() {
        return this.categoryInCloudView;
    }
    
    /**
     * Setter for property categoryInCloudView.
     * @param categoryInCloudView New value of property categoryInCloudView.
     */
    public void setCategoryInCloudView(boolean categoryInCloudView) {
        this.categoryInCloudView = categoryInCloudView;
    }
    /**
     * Holds value of property categoryCloud.
     */
    private java.util.ArrayList<Hyperlink> categoryCloud;
    
    /**
     * Getter for property categoryCloud.
     * @return Value of property categoryCloud.
     */
    public java.util.ArrayList<Hyperlink> getCategoryCloudLinks() {
        CategoryCount [] counts = getApplicationBean1().getPluginSystem().getCategoryCounts();
        /**
         * Sort by name
         */
        Arrays.sort(counts,new CategoryCountComparator(OrderBy.NAME));
        
        String fontsize1="font-size: 10px; font-weight: normal;";
        String fontsize2="font-size: 11px; font-weight: normal;";
        String fontsize3="font-size: 12px; font-weight: normal;";
        String fontsize4="font-size: 13px; font-weight: normal;";
        String fontsize5="font-size: 14px; font-weight: normal;";
        String fontsize6="font-size: 15px; font-weight: normal;";
        
        /**
         * For this tag cloud we will use the linear distribution algorithm with six different "buckets".
         * The algorithm is:
         *  category weight = max number/category - min number/category
         *  range = category weight/number of buckets (6).
         *  distribute the plugins based on category weight for the bucket matching the range.
         *
         */
        CategoryRange categoryRange = getApplicationBean1().getPluginSystem().getCategoryRange();
        long weight = 0;
        long range = 0;
        if(null != categoryRange) {
            weight = categoryRange.getMax() - categoryRange.getMin();
            if(weight < 6) {
                /**
                 * We don't have a very big range of numbers in categories so we need to increase the
                 * weight so the range will be bigger.
                 */
                range = 1;
            } else {
                range = weight/6;
            }
        } else {
            log("Error: category range is null!");
            return null;
        }
        
        /**
         * Dynamically build a hyperlink with an ActionEventListener.  The hyperlink will
         * have the "id" as the category name so the page bean method can determine which link was pressed.
         */
        Hyperlink currentLink = null;
        ArrayList<Hyperlink> newList = new ArrayList();
        for(int ii=0; counts != null && ii < counts.length;ii++) {
            currentLink = new Hyperlink();
            
            currentLink.setText(counts[ii].getCategoryName());
            currentLink.setType(counts[ii].getCategoryName());
            
            MethodExpression method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName()  + ".category_action}",
                    null,
                    new Class[] {ActionEvent.class});
            
            currentLink.setActionListenerExpression(method);
            
            method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName()  + ".category_action}",
                    String.class,
                    new Class[] {});
            currentLink.setActionExpression(method);
            /**
             * now set the cloud rank.
             */
            if(counts[ii].getCount() >= 0 && counts[ii].getCount() <= range) {
                currentLink.setStyle(fontsize1);
            } else if(counts[ii].getCount() >= (range*1) +1 && counts[ii].getCount() <= (range*1)+range) {
                currentLink.setStyle(fontsize2);
            } else if(counts[ii].getCount() >= (range*2) +1 && counts[ii].getCount() <= (range*2)+range) {
                currentLink.setStyle(fontsize3);
            } else if(counts[ii].getCount() >= (range*3) +1 && counts[ii].getCount() <= (range*3)+range) {
                currentLink.setStyle(fontsize4);
            } else if(counts[ii].getCount() >= (range*4) +1 && counts[ii].getCount() <= (range*4)+range) {
                currentLink.setStyle(fontsize5);
            } else {
                currentLink.setStyle(fontsize6);
            }
            currentLink.setStyleClass("category-link");
            currentLink.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/CategoryPage.jsp?categoryname=" + counts[ii].getCategoryName());
            newList.add(currentLink);
            
        }
        this.categoryCloud = newList;
        return this.categoryCloud;
    }
    
    /**
     * Setter for property categoryCloud.
     * @param categoryCloud New value of property categoryCloud.
     */
    public void setCategoryCloudList(java.util.ArrayList<Hyperlink> categoryCloud) {
        this.categoryCloud = categoryCloud;
    }
    
    /**
     * Holds value of property categoryList.
     */
    private ArrayList<Hyperlink> categoryList;
    
    /**
     * Getter for property categoryList.
     * @return Value of property categoryList.
     */
    public ArrayList<Hyperlink> getCategoryList() {
        
        CategoryCount [] counts = getApplicationBean1().getPluginSystem().getCategoryCounts();
        Arrays.sort(counts,new CategoryCountComparator(OrderBy.NAME));
        
        /**
         * Dynamically build a hyperlink with an ActionEventListener.  The hyperlink will
         * have the "id" as the category name so the page bean method can determine which link was pressed.
         */
        Hyperlink currentLink = null;
        ArrayList<Hyperlink> newList = new ArrayList();
        for(int ii=0; counts != null && ii < counts.length;ii++) {
            currentLink = new Hyperlink();
            currentLink.setText(counts[ii].getCategoryName() + "(" + counts[ii].getCount() + ")");
            currentLink.setType(counts[ii].getCategoryName());
            
            MethodExpression method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName()  + ".category_action}",
                    null,
                    new Class[] {ActionEvent.class});
            
            currentLink.setActionListenerExpression(method);
            
            method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName()  + ".category_action}",
                    String.class,
                    new Class[] {});
            currentLink.setActionExpression(method);
            currentLink.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/CategoryPage.jsp?categoryname=" + counts[ii].getCategoryName());
            newList.add(currentLink);
        }
        categoryList = newList;
        return this.categoryList;
    }
    
    /**
     * Holds value of property currentPageName.
     */
    private String currentPageName;
    
    /**
     * Getter for property currentPageName.
     * @return Value of property currentPageName.
     */
    public String getCurrentPageName() {
        return this.currentPageName;
    }
    
    /**
     * Setter for property currentPageName.
     * @param currentPageName New value of property currentPageName.
     */
    public void setCurrentPageName(String currentPageName) {
        this.currentPageName = currentPageName;
    }
    
    /**
     * Holds value of property topRatedList.
     */
    private ArrayList<Hyperlink> topRatedList;
    
    /**
     * Getter for property topRatedList.
     * @return Value of property topRatedList.
     */
    public ArrayList<Hyperlink> getTopRatedList() {
        Plugin [] plugins = getApplicationBean1().getPluginSystem().getTopRatedPlugins(10);
        
        topRatedList = makePluginHyperLinks(plugins);
        return topRatedList;
    }
    
    private ArrayList makePluginHyperLinks(Plugin [] inPlugins) {
        /**
         * Dynamically build a hyperlink with an ActionEventListener.  The hyperlink will
         * have the "url" as the plugin id so the page bean method can determine which plugin was selected.
         */
        Hyperlink currentLink = null;
        ArrayList<Hyperlink> newList = new ArrayList();
        for(int ii=0; inPlugins != null && ii < inPlugins.length;ii++) {
            currentLink = new Hyperlink();
            /**
             * Need to gracefully truncate words greater than 20 characters in the name.
             */
            String truncatedName = truncName(inPlugins[ii].getPlugin_name());
            currentLink.setText(ii+1 + ". " + truncatedName);
            currentLink.setType(inPlugins[ii].getPluginid().toString());
            
            MethodExpression method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName() + ".pluginselect_action}",
                    null,
                    new Class[] {ActionEvent.class});
            
            currentLink.setActionListenerExpression(method);
            
            method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                    "#{" + getCurrentPageName() + ".pluginselect_action}",
                    String.class,
                    new Class[] {});
            currentLink.setActionExpression(method);
            currentLink.setStyleClass("toplist-link");
            currentLink.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginDetailPage.jsp?pluginid=" +inPlugins[ii].getPluginid());
            newList.add(currentLink);
        }
        
        return newList;
    }
    
    /**
     * Holds value of property topDownloadedList.
     */
    private ArrayList<Hyperlink> topDownloadedList;
    
    /**
     * Getter for property topDownloadedList.
     * @return Value of property topDownloadedList.
     */
    public ArrayList<Hyperlink> getTopDownloadedList() {
        Plugin [] plugins = getApplicationBean1().getPluginSystem().getTopDownloadsPlugins(10);
        
        topDownloadedList = makePluginHyperLinks(plugins);
        return topDownloadedList;
    }
    
    /**
     * Holds value of property recentlyAddedList.
     */
    private ArrayList<Hyperlink> recentlyAddedList;
    
    /**
     * Getter for property recentlyAddedList.  We must get the current page name from
     * the application bean because passing a parameter makes this NOT a getter method
     * which breaks the data binding.
     * @return Value of property recentlyAddedList.
     */
    public ArrayList<Hyperlink> getRecentlyAddedList() {
        Plugin [] plugins = getApplicationBean1().getPluginSystem().getRecentlyAddedPlugins(10);
        
        recentlyAddedList = makePluginHyperLinks(plugins);
        return recentlyAddedList;
    }
    
    /**
     * Holds value of property notRateable.
     */
    private boolean notRateable;
    
    /**
     * Getter for property notRateable.
     * @return Value of property notRateable.
     */
    public boolean isNotRateable() {
        return !isRateable();
    }
    
    /**
     * Setter for property notRateable.
     * @param notRateable New value of property notRateable.
     */
    public void setNotRateable(boolean notRateable) {
        this.notRateable = notRateable;
    }
    
    /**
     * Holds value of property attemptedComment.
     */
    private boolean attemptedComment=false;
    
    /**
     * Getter for property attemptedComment.
     * @return Value of property attemptedComment.
     */
    public boolean isAttemptedComment() {
        return this.attemptedComment;
    }
    
    /**
     * Setter for property attemptedComment.
     * @param attemptedComment New value of property attemptedComment.
     */
    public void setAttemptedComment(boolean attemptedComment) {
        this.attemptedComment = attemptedComment;
    }
    
    /**
     * Holds value of property selectedTargetPlatforms.
     */
    private String[] selectedTargetPlatforms;
    
    /**
     * Getter for property selectedTargetPlatforms.
     * @return Value of property selectedTargetPlatforms.
     */
    public String[] getSelectedTargetPlatforms() {
        return this.selectedTargetPlatforms;
    }
    
    /**
     * Setter for property selectedTargetPlatforms.
     * @param selectedTargetPlatforms New value of property selectedTargetPlatforms.
     */
    public void setSelectedTargetPlatforms(String[] selectedTargetPlatforms) {
        this.selectedTargetPlatforms = selectedTargetPlatforms;
    }
    
    /**
     * Holds value of property thumbimageUploadFile.
     */
    private UploadedFile thumbimageUploadFile;
    
    /**
     * Getter for property thumbimageUploadFile.
     * @return Value of property thumbimageUploadFile.
     */
    public UploadedFile getThumbimageUploadFile() {
        return this.thumbimageUploadFile;
    }
    
    /**
     * Setter for property thumbimageUploadFile.
     * @param thumbimageUploadFile New value of property thumbimageUploadFile.
     */
    public void setThumbimageUploadFile(UploadedFile thumbimageUploadFile) {
        this.thumbimageUploadFile = thumbimageUploadFile;
    }
    
    /**
     * Holds value of property showWhatsNew.
     */
    private boolean showWhatsNew;
    
    /**
     * Getter for property showWhatsNew.
     * @return Value of property showWhatsNew.
     */
    public boolean isShowWhatsNew() {
        if(null != getCurrentPlugin() &&
                null != getCurrentPlugin().getDate_last_updated()) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * Setter for property showWhatsNew.
     * @param showWhatsNew New value of property showWhatsNew.
     */
    public void setShowWhatsNew(boolean showWhatsNew) {
        this.showWhatsNew = showWhatsNew;
    }
    
    public boolean login(String userid, String password) {
        
        HttpServletRequest request = (HttpServletRequest)getExternalContext().getRequest();
        this.getApplicationBean1().getPluginSystem().refreshRequest(request); //nb.org login hack.
        String authToken = this.getApplicationBean1().getPluginSystem().login(userid,password);
        if(null != authToken) {
            setAuthToken(authToken);
            setCurrentUserId(userid);
            return true;
        } else {
            return false;
        }
        
    }
    
    public void logoff() {
        this.getApplicationBean1().getPluginSystem().logoff(getCurrentUserId());
        setAuthToken(null);
        setCurrentUserId(null);
    }
    
    /**
     *  We can't use this hack currently because we need a way to get the userid so we'll have
     * to force a login.
     *
     * This is a hack to determine if the user is already logged into netbeans.org.
     *
     * We do this on the session because this type of functionality is specific to a web application
     * at the session level.  This functionality is not appropriate for the back end plugin system that
     * doesn't know about Servlet requests and responses.
     */
    public boolean isAlreadyLoggedIn() {
        HttpServletResponse response = null;
        HttpServletRequest request = null;
        response = (HttpServletResponse)getExternalContext().getResponse();
        request = (HttpServletRequest)getExternalContext().getRequest();
        
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out;
        try {
            out = response.getWriter();
        } catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
        Cookie[] cookies = request.getCookies();
        if (request.getCookies()==null) {
            return false;
        }
        
        
        URL url=null;
        URLConnection urlConn=null;
        DataOutputStream printout=null;
        DataInputStream input=null;
        try {
            url = new URL("http://www.netbeans.org/issues/enter_bug.cgi");
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
            return false;
        }
        try {
            urlConn = url.openConnection();
        } catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
//        urlConn.setRequestProperty("Host","test.netbeans.org");
        Map<String,String> env = System.getenv();
        Properties props = System.getProperties();
        urlConn.setDoInput(true);
        urlConn.setDoOutput(true);
        urlConn.setUseCaches(false);
        String cookieString = "";
        String delim = "";
        for (int i=0; i<cookies.length; i++) {
            if (i<cookies.length-1) {
                delim = "; ";
            } else {
                delim = "";
            }
            cookieString+=cookies[i].getName()+"="+cookies[i].getValue()+delim;
        }
        urlConn.setRequestProperty("Cookie", cookieString);
        try {
            //out.print(cookieString);
            
            // Get response data
            input = new DataInputStream(urlConn.getInputStream());
        } catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
        String str;
        boolean loggedIn = true;
        String totalPage = "";
        try {
            while (null != ((str = input.readLine()))) {
                // catch message displayed when logged in correctly
                // by default the user is not logged in
                if (str.contains("Permission denied")) {
                    loggedIn = false;
                }
                totalPage += str;
            }
            input.close();
        } catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
        
        out.close();
        
        if (loggedIn) {
            return true;
        } else {
            return false;
        }
        
    }
    
    ArrayList<Hyperlink> getCategoryHyperlinkList(Plugin plugin) {
        Hyperlink currentLink = null;
        ArrayList<Hyperlink> newList = new ArrayList();
        /**
         * Dynamically build a hyperlink with an ActionEventListener.  The hyperlink will
         * have the "id" as the category name so the page bean method can determine which link was pressed.
         */
        
        /**
         * Add the other categories.
         */
        Collection<OtherCategory> categories = plugin.getOthercategories();
        OtherCategory currentOtherCategory = null;
        if(null != categories) {
            Iterator<OtherCategory> iterator = categories.iterator();
            while(iterator.hasNext()) {
                currentLink = new Hyperlink();
                currentOtherCategory = iterator.next();
                currentLink.setText(currentOtherCategory.getCategoryname());
                currentLink.setType(currentOtherCategory.getCategoryname());
                
                MethodExpression method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                        "#{" + getCurrentPageName()  + ".category_action}",
                        null,
                        new Class[] {ActionEvent.class});
                
                currentLink.setActionListenerExpression(method);
                
                method = this.getApplication().getExpressionFactory().createMethodExpression(FacesContext.getCurrentInstance().getELContext(),
                        "#{" + getCurrentPageName()  + ".category_action}",
                        String.class,
                        new Class[] {});
                currentLink.setActionExpression(method);
                currentLink.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/CategoryPage.jsp?categoryname=" + currentOtherCategory.getCategoryname());
                newList.add(currentLink);
            }
            
        }
        return newList;
    }
    
    /**
     * Holds value of property returnFromModifyPage.
     */
    private String returnFromModifyPage;
    
    /**
     * Getter for property returnFromModifyPage.
     * @return Value of property returnFromModifyPage.
     */
    public String getReturnFromModifyPage() {
        return this.returnFromModifyPage;
    }
    
    /**
     * Setter for property returnFromModifyPage.
     * @param returnFromModifyPage New value of property returnFromModifyPage.
     */
    public void setReturnFromModifyPage(String returnFromModifyPage) {
        this.returnFromModifyPage = returnFromModifyPage;
    }
    
    private String truncName(String inName) {
        if(null == inName) {
            return null;
        }
        
        String words[] = inName.split(" ");
        String returnString = "";
        String currentWord = "";
        for(int ii=0; null != words && ii < words.length; ii++) {
            
            if(words[ii].length() >= 20) {
                currentWord = words[ii].substring(0,17) + "...";
            } else {
                currentWord = words[ii];
            }
            
            if(!returnString.equals("")) {
                returnString += " ";
            }
            
            returnString += currentWord;
            
        }
        
        return returnString;
    }
    
    
    
    
}
