<?xml version="1.0" encoding="UTF-8" ?>
<!--
DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.


The contents of this file are subject to the terms of either the GNU
General Public License Version 2 only ("GPL") or the Common
Development and Distribution License("CDDL") (collectively, the
"License"). You may not use this file except in compliance with the
License. You can obtain a copy of the License at
http://www.netbeans.org/cddl-gplv2.html
or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
specific language governing permissions and limitations under the
License.  When distributing the software, include this License Header
Notice in each file and include the License file at
nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
particular file as subject to the "Classpath" exception as provided
by Sun in the GPL Version 2 section of the License file that
accompanied this code. If applicable, add the following below the
License Header, with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

Contributor(s):

The Original Software is NetBeans. The Initial Developer of the Original
Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
Microsystems, Inc. All Rights Reserved.

If you wish your version of this file to be governed by only the CDDL
or only the GPL Version 2, indicate your decision by adding
"[Contributor] elects to include this software in this distribution
under the [CDDL or GPL Version 2] license." If you do not indicate a
single choice of license, a recipient has the option to distribute
your version of this file under either the CDDL, the GPL Version 2 or
to extend the choice of license to its licensees as provided above.
However, if you add GPL Version 2 code and therefore, elected the GPL
Version 2 license, then the option applies only if the new code is
made subject to such option by the copyright holder.
-->
<!DOCTYPE stylesheet [
    <!ENTITY notavailable "N/A">
    <!ENTITY vcs_modules "component='javacvs' or component='vcscore' or component='diff' or component='vcsgeneric'">
    <!ENTITY openide_modules "component='openide' or component='openidex'">
    <!ENTITY debugger_modules "component='debuggercore' or component='debuggerjpda'">
    <!ENTITY webapps_modules "component='applet' or component='extbrowser' or component='httpserver' or component='monitor' or component='tomcatint' or component='web' or component='j2eeserver' or component='html' or component='schema2beans'">
    <!ENTITY j2ee_modules "component='j2ee' or component='websvc' or component='serverplugins'">
]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:java="java" xmlns:Date="java:java.util.Date" xmlns:SimpleDateFormat="java:java.text.SimpleDateFormat">
<xsl:preserve-space elements=""/>
<xsl:output method="xml" indent="yes" />

<xsl:param name="build_name" />
<xsl:param name="build_no" />
<xsl:param name="recommend" />


<xsl:template match="issuezilla">
    
    <!-- create todays date -->
    <xsl:variable name="formatter" select="java:text.SimpleDateFormat.new('yyyyMMdd')"/>
    <xsl:variable name="date" select="java:util.Date.new()"/>
    <xsl:variable name="datestamp"  select="SimpleDateFormat:format($formatter,$date)"/>

<qbuild-report datestamp="{$datestamp}" recommend="{$recommend}" date="{concat(substring($date,9,2), '/',substring($date,5,3),'/',substring($date,26,4))}" build="{$build_no}" name="{$build_name}">
        
    <xsl:text>
    
    </xsl:text>
    <xsl:text disable-output-escaping="yes">&lt;!--</xsl:text> Fill promoted build number and date here<xsl:text disable-output-escaping="yes">--&gt;</xsl:text>
    <xsl:text>
    </xsl:text>
        
    <promoted-build>
            <xsl:choose>
                <xsl:when test="$recommend='yes'"><xsl:value-of select="$build_no"/></xsl:when>
                <xsl:otherwise>&notavailable;</xsl:otherwise>
             </xsl:choose>   
    </promoted-build>
    <xsl:text>
    </xsl:text>
    <promoted-date>
            <xsl:choose>
                <xsl:when test="$recommend='yes'"><xsl:value-of select="concat(substring($date,9,2), '/',substring($date,5,3),'/',substring($date,26,4))"/></xsl:when>
                <xsl:otherwise>&notavailable;</xsl:otherwise>
            </xsl:choose> 
    </promoted-date>

           
<xsl:text>
    
    </xsl:text>
    <xsl:text disable-output-escaping="yes">&lt;!--</xsl:text> Fill Dont's for this build here<xsl:text disable-output-escaping="yes">--&gt;</xsl:text>
    <xsl:text>
    </xsl:text>
    <donts>
        [Dont's PENDING]
    </donts>
    
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'ant'"/>
        </xsl:call-template>

        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'apisupport'"/>
        </xsl:call-template>

        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'autoupdate'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'beans'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'clazz'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'core'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'debugger'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'db'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'editor'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'form'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'i18n'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'installer'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'java'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'javadoc'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'junit'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'mdr'"/>
        </xsl:call-template>

        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'openide'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'projects'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'properties'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'refactoring'"/>
        </xsl:call-template>

        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'tasklist'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'text'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'utilities'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'ui'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'vcs'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'webapps'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'j2ee'"/>
        </xsl:call-template>
        
        <xsl:call-template name="process-component">
            <xsl:with-param name="component_name" select="'xml'"/>
        </xsl:call-template>
        
    </qbuild-report>
</xsl:template>


<xsl:template name="process-component">
    <xsl:param name="component_name"/>

    <xsl:text>
    
    </xsl:text>
    <xsl:text disable-output-escaping="yes">&lt;!-- </xsl:text><xsl:value-of select="$component_name"/><xsl:text disable-output-escaping="yes"> --&gt;</xsl:text>
    <xsl:text>
    </xsl:text>
    <component name="{$component_name}">
    
    <xsl:choose>
        <xsl:when test="$component_name='vcs'">
            <xsl:for-each select="/issuezilla/issue[&vcs_modules;]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:when test="$component_name='openide'">
            <xsl:for-each select="/issuezilla/issue[&openide_modules;]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:when test="$component_name='debugger'">
            <xsl:for-each select="/issuezilla/issue[&debugger_modules;]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:when test="$component_name='webapps'">
            <xsl:for-each select="/issuezilla/issue[&webapps_modules;]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:when test="$component_name='j2ee'">
            <xsl:for-each select="/issuezilla/issue[&j2ee_modules;]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
            <xsl:for-each select="/issuezilla/issue[component=$component_name]">  
                <xsl:call-template name="process-issue">
                    <xsl:with-param name="issue-id" select="issue_id"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:otherwise>
      </xsl:choose>      
    <xsl:text>
    </xsl:text>  
    </component>
      
</xsl:template>

<xsl:template name="process-issue">
        <xsl:param name="issue-id"/>
        <xsl:variable name="p" select="priority"/>
        <xsl:variable name="tf" select="@to-fix"/>
        <xsl:variable name="st" select="@stopper"/>
        
        <xsl:for-each select="//issue[issue_id=$issue-id]">
<xsl:text>
        </xsl:text>                    
<issue to-fix="{$tf}" stopper="{$st}" priority="{$p}" id="{$issue-id}">
<xsl:text>
            </xsl:text>                    
    <short_desc><xsl:value-of select="short_desc"/></short_desc>
<xsl:text>
            </xsl:text>                        
    <time><xsl:value-of select="creation_ts"/></time>
<xsl:text>
        </xsl:text>                        
</issue>    
  
        </xsl:for-each>    
</xsl:template>

</xsl:stylesheet>
