/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.find;

/**
 *
 * @author ehucka
 */
public class ReplaceOccurance extends FoundOccurance implements Comparable {
    
    String replaced;
    /**
     * Creates a new instance of ReplaceOccurance
     */
    public ReplaceOccurance(int start, int end, String value, String replaced) {
        super(start, end, value);
        this.replaced = replaced;
    }
    
    protected String createHtmlText() {
        StringBuilder sb=new StringBuilder();
        sb.append("<html>");
        if (isPredots())
            sb.append("...");
        sb.append(getPrefix().replace("<", "&lt;"));
        sb.append("<b>");
        sb.append(getPattern().replace("<", "&lt;"));
        sb.append("</b>");
        sb.append(getSuffix().replace("<", "&lt;"));
        if (isPostdots())
            sb.append("...");
        sb.append(" -> ");
        if (isPredots())
            sb.append("...");
        sb.append(getPrefix().replace("<", "&lt;"));
        sb.append("<b>");
        sb.append(replaced.replace("<", "&lt;"));
        sb.append("</b>");
        sb.append(getSuffix().replace("<", "&lt;"));
        if (isPostdots())
            sb.append("...");
        return sb.toString();
    }
    
    public void replace() {
        String cont=getBean().getValue().getContent();
        StringBuilder sb=new StringBuilder();
        sb.append(cont.substring(0, getStart()));
        sb.append(replaced);
        sb.append(cont.substring(getEnd()));
        getBean().getValue().setContent(sb.toString());
    }
    
    public int compareTo(Object o) {
        ReplaceOccurance ro=(ReplaceOccurance)o;
        if (ro.getBean() != getBean()) {
            return getBean().getName().compareTo(ro.getBean().getName());
        } else {
            return ro.getStart()-getStart();
        }
    }
}
