/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.util.LinkedList;
import javax.swing.JTree;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.beans.TestAction;
import org.netbeans.testspeceditor.beans.TestCase;
import org.netbeans.testspeceditor.beans.TestSuite;
import org.netbeans.testspeceditor.events.Bean;
import org.netbeans.testspeceditor.find.FindEngine;
import org.netbeans.testspeceditor.find.FindPattern;
import org.netbeans.testspeceditor.find.FoundBean;
import org.netbeans.testspeceditor.find.HighLightingSupport;
import org.netbeans.testspeceditor.ui.status.StatusManager;
import org.netbeans.testspeceditor.ui.tree.CasesNode;
import org.netbeans.testspeceditor.ui.tree.DataNode;
import org.netbeans.testspeceditor.ui.tree.Node;
import org.netbeans.testspeceditor.ui.tree.SuitesNode;
import org.netbeans.testspeceditor.ui.tree.TestSpecNode;
import org.netbeans.testspeceditor.ui.tree.find.FoundBeanNode;
import org.netbeans.testspeceditor.ui.tree.find.FoundTreeModel;
import org.netbeans.testspeceditor.ui.tree.find.FoundTreeRenderer;
import org.netbeans.testspeceditor.utils.Utils;

/**
 *
 * @author  ehucka
 */
public class FindDialog extends javax.swing.JDialog {
    
    static LinkedList<String> founds=new LinkedList();
    
    private FoundTreeModel treeModel;
    
    HistoryComboModel model;
    
    Node[] selected = null;
    
    /** Creates new form FindDialog */
    public FindDialog(Node[] selected) {
        super(Application.getInstance().getUi(), false);
        model=new HistoryComboModel(founds);
        this.selected = selected;
        treeModel=new FoundTreeModel();
        initComponents();
        setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,
                getParent().getY()+(getParent().getHeight()-getHeight())/2);
        getRootPane().setDefaultButton(findB);
    }
    
    public FoundTreeModel getTreeModel() {
        return treeModel;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        findWhatC = new javax.swing.JComboBox();
        findB = new javax.swing.JButton();
        matchCase = new javax.swing.JCheckBox();
        wholeWord = new javax.swing.JCheckBox();
        reguralExprs = new javax.swing.JCheckBox();
        stornoB = new javax.swing.JButton();
        selectedNodes = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new JTree(getTreeModel());
        jLabel2 = new javax.swing.JLabel();
        packRadio = new javax.swing.JRadioButton();
        expandRadio = new javax.swing.JRadioButton();
        highlight = new javax.swing.JCheckBox();

        setTitle("Find");
        jLabel1.setDisplayedMnemonic('f');
        jLabel1.setFont(new java.awt.Font("Dialog", 0, 11));
        jLabel1.setText("Find What:");

        findWhatC.setEditable(true);
        findWhatC.setFont(new java.awt.Font("Dialog", 0, 12));
        findWhatC.setModel(model);

        findB.setFont(new java.awt.Font("Dialog", 0, 12));
        findB.setMnemonic('d');
        findB.setText("Find");
        findB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        findB.setPreferredSize(new java.awt.Dimension(80, 24));
        findB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findBActionPerformed(evt);
            }
        });

        matchCase.setFont(new java.awt.Font("Dialog", 0, 11));
        matchCase.setMnemonic('m');
        matchCase.setText("Match Case");
        matchCase.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        matchCase.setMargin(new java.awt.Insets(0, 0, 0, 0));

        wholeWord.setFont(new java.awt.Font("Dialog", 0, 11));
        wholeWord.setMnemonic('w');
        wholeWord.setText("Whole Word");
        wholeWord.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        wholeWord.setMargin(new java.awt.Insets(0, 0, 0, 0));

        reguralExprs.setFont(new java.awt.Font("Dialog", 0, 11));
        reguralExprs.setMnemonic('x');
        reguralExprs.setText("Regural Expressions");
        reguralExprs.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        reguralExprs.setMargin(new java.awt.Insets(0, 0, 0, 0));
        reguralExprs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reguralExprsActionPerformed(evt);
            }
        });

        stornoB.setFont(new java.awt.Font("Dialog", 0, 12));
        stornoB.setMnemonic('c');
        stornoB.setText("Close");
        stornoB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        stornoB.setPreferredSize(new java.awt.Dimension(80, 24));
        stornoB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stornoBActionPerformed(evt);
            }
        });

        selectedNodes.setFont(new java.awt.Font("Dialog", 0, 11));
        selectedNodes.setMnemonic('n');
        selectedNodes.setText("Selected Nodes");
        selectedNodes.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        selectedNodes.setMargin(new java.awt.Insets(0, 0, 0, 0));

        tree.setCellRenderer(new FoundTreeRenderer());
        tree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                treeMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(tree);

        jLabel2.setDisplayedMnemonic('o');
        jLabel2.setFont(new java.awt.Font("Dialog", 0, 11));
        jLabel2.setText("Found Occurances:");

        buttonGroup1.add(packRadio);
        packRadio.setFont(new java.awt.Font("Dialog", 0, 10));
        packRadio.setMnemonic('p');
        packRadio.setSelected(true);
        packRadio.setText("Pack");
        packRadio.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        packRadio.setMargin(new java.awt.Insets(0, 0, 0, 0));
        packRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                packRadioActionPerformed(evt);
            }
        });

        buttonGroup1.add(expandRadio);
        expandRadio.setFont(new java.awt.Font("Dialog", 0, 10));
        expandRadio.setMnemonic('e');
        expandRadio.setText("Expand All");
        expandRadio.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        expandRadio.setMargin(new java.awt.Insets(0, 0, 0, 0));
        expandRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expandRadioActionPerformed(evt);
            }
        });

        highlight.setFont(new java.awt.Font("Dialog", 0, 11));
        highlight.setMnemonic('h');
        highlight.setSelected(true);
        highlight.setText("HighLight Results");
        highlight.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        highlight.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 509, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jLabel1)
                        .add(3, 3, 3)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(findWhatC, 0, 365, Short.MAX_VALUE)
                                .add(6, 6, 6))
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(matchCase)
                                    .add(wholeWord))
                                .add(12, 12, 12)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(reguralExprs)
                                    .add(selectedNodes))
                                .add(116, 116, 116))
                            .add(layout.createSequentialGroup()
                                .add(highlight)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(findB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(stornoB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(packRadio)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(expandRadio)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(findWhatC, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(findB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(matchCase)
                            .add(selectedNodes))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(wholeWord)
                            .add(reguralExprs)))
                    .add(stornoB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 24, Short.MAX_VALUE)
                .add(highlight)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(packRadio)
                    .add(expandRadio))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 219, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void expandRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_expandRadioActionPerformed
        for (int i = 0; i < tree.getRowCount(); i++) {
            tree.expandRow(i);
        }
    }//GEN-LAST:event_expandRadioActionPerformed
    
    private void packRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_packRadioActionPerformed
        for (int i = 1; i < tree.getRowCount(); i++) { //not the first root node
            tree.collapseRow(i);
        }
    }//GEN-LAST:event_packRadioActionPerformed
    
    private void treeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_treeMouseClicked
        if (evt.getClickCount() >= 2 && tree.getSelectionPath() != null) {
            Node n=(Node)(tree.getSelectionPath().getLastPathComponent());
            if (n != null) {
                FoundBeanNode bn;
                if (n instanceof FoundBeanNode)
                    bn=(FoundBeanNode)n;
                else
                    bn=(FoundBeanNode)(n.getParent());
                if (bn != null) {
                    FoundBean fb = bn.getFoundBean();
                    Bean b = null;
                    if (fb.getValue() instanceof TestAction)
                        b = fb.getValue();
                    else
                        b = fb.getPresentedBean();
                    Application.getInstance().getUi().selectNodeFor(b);
                }
            }
        }
    }//GEN-LAST:event_treeMouseClicked
    
    private void reguralExprsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reguralExprsActionPerformed
        if (reguralExprs.isSelected()) {
            wholeWord.setEnabled(false);
        } else {
            wholeWord.setEnabled(true);
        }
    }//GEN-LAST:event_reguralExprsActionPerformed
    
    private void stornoBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stornoBActionPerformed
        setVisible(false);
    }//GEN-LAST:event_stornoBActionPerformed
    
    private void findBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findBActionPerformed
        StatusManager.getInstance().setWaitCursor(true);
        try {
            String pat=(String)findWhatC.getSelectedItem();
            FindPattern pattern=new FindPattern(pat, matchCase.isSelected(),
                    wholeWord.isSelected(), reguralExprs.isSelected(), selectedNodes.isSelected());
            FindEngine fe=new FindEngine(pattern);
            
            if (selectedNodes.isSelected()) {
                if (selected != null) {
                    Node[] nodes=Utils.getSelectedNodesOneInPath(selected);
                    for (int i = 0; i < nodes.length; i++) {
                        if (nodes[i] instanceof TestSpecNode) {
                            fe.find(((TestSpecNode)nodes[i]).getTestSpec(), null, -1);
                            break;
                        } else if (nodes[i] instanceof SuitesNode) {
                            TestSuite[] ts=Application.getInstance().getDocument().getTestSpec().getTestSuites();
                            for (int j = 0; j < ts.length; j++) {
                                fe.find(ts[j], null, -1);
                            }
                        } else if (nodes[i] instanceof CasesNode) {
                            TestCase[] tc=Application.getInstance().getDocument().getTestSpec().getTestCases();
                            for (int j = 0; j < tc.length; j++) {
                                fe.find(tc[j], null, -1);
                            }
                        } else {
                            Node par=(Node)nodes[i].getParent();
                            fe.find((Bean)((DataNode)nodes[i]).getData(), (par instanceof DataNode)?
                                (Bean)((DataNode)par).getData():null, (par instanceof DataNode)?
                                    par.getIndex(nodes[i]):-1);
                        }
                    }
                }
            } else {
                fe.find();
            }
            if (highlight.isSelected()) {
                HighLightingSupport.getInstance().setPattern(pattern);
            }
            HighLightingSupport.getInstance().setHighlight(highlight.isSelected());
            
            getTreeModel().setRoot(fe.getFoundData());
            if (!founds.contains(pat)) {
                founds.addFirst(pat);
                model.fireEventAddFirst();
            } else {
                int ind=founds.indexOf(pat);
                founds.remove(ind);
                model.fireEventRemove(ind);
                founds.addFirst(pat);
                model.fireEventAddFirst();
            }
        } finally {
            StatusManager.getInstance().setWaitCursor(false);
        }
    }//GEN-LAST:event_findBActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton expandRadio;
    private javax.swing.JButton findB;
    private javax.swing.JComboBox findWhatC;
    private javax.swing.JCheckBox highlight;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox matchCase;
    private javax.swing.JRadioButton packRadio;
    private javax.swing.JCheckBox reguralExprs;
    private javax.swing.JCheckBox selectedNodes;
    private javax.swing.JButton stornoB;
    private javax.swing.JTree tree;
    private javax.swing.JCheckBox wholeWord;
    // End of variables declaration//GEN-END:variables
    
}
