/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.regex.Pattern;
import javax.swing.ComboBoxModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.utils.FileUtil;

/**
 *
 * @author  ehucka
 */
public class ParseXParametersDialog extends javax.swing.JDialog {
    
    String xrepository, xtestype, xmodule, xmethod;
    ArrayList<String> methods=new ArrayList(64);
    Model model;
    boolean state=false;
    
    /** Creates new form ParseXParametersDialog */
    public ParseXParametersDialog() {
        super(Application.getInstance().getUi(), true);
        model=new Model();
        initComponents();
        setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,
                getParent().getY()+(getParent().getHeight()-getHeight())/2);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel7 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        caseRepositoryF = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        caseModuleF = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        caseTestTypeF = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        loadB = new javax.swing.JButton();
        confirmB = new javax.swing.JButton();
        stornoB = new javax.swing.JButton();
        methodsC = new javax.swing.JComboBox();

        FormListener formListener = new FormListener();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Select Test Source In CVS Repository");
        jLabel3.setText("XRepository:");

        jLabel4.setText("XModule:");

        jLabel5.setText("XTestType:");

        jLabel6.setText("XMethod:");

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 10));

        loadB.setText("Load Source");
        loadB.setMargin(new java.awt.Insets(2, 10, 2, 10));
        loadB.setPreferredSize(new java.awt.Dimension(105, 24));
        loadB.addActionListener(formListener);

        jPanel1.add(loadB);

        confirmB.setText("Confirm");
        confirmB.setMargin(new java.awt.Insets(2, 10, 2, 10));
        confirmB.setPreferredSize(new java.awt.Dimension(80, 24));
        confirmB.addActionListener(formListener);

        jPanel1.add(confirmB);

        stornoB.setText("Close");
        stornoB.setMargin(new java.awt.Insets(2, 10, 2, 10));
        stornoB.setPreferredSize(new java.awt.Dimension(80, 24));
        stornoB.addActionListener(formListener);

        jPanel1.add(stornoB);

        methodsC.setModel(model);

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel3)
                    .add(caseRepositoryF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
                    .add(jLabel4)
                    .add(caseModuleF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
                    .add(jLabel5)
                    .add(caseTestTypeF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
                    .add(jLabel6)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
                    .add(methodsC, 0, 424, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(caseRepositoryF, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(caseModuleF, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel5)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(caseTestTypeF, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel6)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(methodsC, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(1, 1, 1)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(13, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        pack();
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener {
        FormListener() {}
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == loadB) {
                ParseXParametersDialog.this.loadBActionPerformed(evt);
            }
            else if (evt.getSource() == confirmB) {
                ParseXParametersDialog.this.confirmBActionPerformed(evt);
            }
            else if (evt.getSource() == stornoB) {
                ParseXParametersDialog.this.stornoBActionPerformed(evt);
            }
        }
    }// </editor-fold>//GEN-END:initComponents
    
    private void stornoBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stornoBActionPerformed
        setState(false);
        closeDialog();
    }//GEN-LAST:event_stornoBActionPerformed
    
    private void confirmBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_confirmBActionPerformed
        setState(true);
        xrepository=caseRepositoryF.getText();
        xmodule=caseModuleF.getText();
        xtestype=caseTestTypeF.getText();
        xmethod=(String)(methodsC.getSelectedItem());
        closeDialog();
    }//GEN-LAST:event_confirmBActionPerformed
    
    private void loadBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadBActionPerformed
        String file=FileUtil.openFileDialog(true, "Select Test Source File in CVS", false, new String[] {"java"}, "Java");
        if (file != null) {
            methods.clear();
            try {
                BufferedReader br=new BufferedReader(new FileReader(file));
                String line;
                Pattern p = Pattern.compile(".*public\\s+void\\s+test[\\w\\s]+\\(\\).*");
                while ((line=br.readLine()) != null) {
                    if (p.matcher(line).matches()) {
                        String name=line.substring(line.indexOf("void")+4, line.indexOf('('));
                        methods.add(name.trim());
                    }
                }
                br.close();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
            model.fireEvent();
            File cvsroot=new File(file);
            cvsroot=new File(cvsroot.getParentFile(), "CVS/Root");
            if (cvsroot.exists()) {
                try {
                    BufferedReader br=new BufferedReader(new FileReader(cvsroot));
                    String line=br.readLine().trim();
                    br.close();
                    caseRepositoryF.setText(line);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
            File cvsrep=new File(file);
            cvsrep=new File(cvsrep.getParentFile(), "CVS/Repository");
            String repository=null;
            if (cvsrep.exists()) {
                try {
                    BufferedReader br=new BufferedReader(new FileReader(cvsrep));
                    String line=br.readLine().trim();
                    br.close();
                    repository=line;    // module/test/unit/src/package
                    //file is /space/cvs/data/module/test/unit/src/package/Class.java
                    if (!File.separator.equals("/"))
                        file=file.replace(File.separator, "/");
                    String root=file.substring(file.indexOf(repository));  // module/test/unit/src/package/Class.java
                    String module=root.substring(0, root.indexOf("/test/"));
                    root=root.substring(root.indexOf("/test/")+6);
                    String testtype=root.substring(0, root.indexOf("/src/"));
                    caseTestTypeF.setText(testtype);
                    caseModuleF.setText(module);
                } catch (Exception ex) {
                    System.err.println("file "+file);
                    System.err.println("repository "+repository);
                    ex.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_loadBActionPerformed
    
    protected void closeDialog() {
        setVisible(false);
        dispose();
    }
    
    class Model implements ComboBoxModel {
        
        ArrayList<ListDataListener> lis=new ArrayList(4);
        
        String selected=null;
        
        public void setSelectedItem(Object anItem) {
            selected=(String)anItem;
        }
        
        public Object getElementAt(int index) {
            return methods.get(index);
        }
        
        public void removeListDataListener(javax.swing.event.ListDataListener l) {
            lis.remove(l);
        }
        
        public void addListDataListener(javax.swing.event.ListDataListener l) {
            lis.add(l);
        }
        
        public void fireEvent() {
            for (ListDataListener l:lis) {
                l.contentsChanged(new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, methods.size()-1));
            }
        }
        
        public int getSize() {
            return methods.size();
        }
        
        public Object getSelectedItem() {
            return selected;
        }
    }
    
    public String getXrepository() {
        return xrepository;
    }
    
    public String getXtestype() {
        return xtestype;
    }
    
    public String getXmodule() {
        return xmodule;
    }
    
    public String getXmethod() {
        return xmethod;
    }
    
    public boolean isState() {
        return state;
    }
    
    public void setState(boolean state) {
        this.state = state;
    }
    
    public static void main(String[] args) {
        Pattern p = Pattern.compile(".*public\\s+void\\s+test[\\w\\s]+\\(\\).*");//public\\s+void\\s+test[\\w\\s]+\\(\\)
        System.err.println(p.matcher("      public void testAaa (String s) {").matches());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField caseModuleF;
    private javax.swing.JTextField caseRepositoryF;
    private javax.swing.JTextField caseTestTypeF;
    private javax.swing.JButton confirmB;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JButton loadB;
    private javax.swing.JComboBox methodsC;
    private javax.swing.JButton stornoB;
    // End of variables declaration//GEN-END:variables
    
}
