/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.io.File;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.utils.FileUtil;

/**
 *
 * @author  eh103527
 */
public class TwoFilesDialog extends JDialog {
    
    File main,repository;
    
    boolean state=false;
    
    /**
     * Creates new form TwoFilesDialog
     */
    public TwoFilesDialog() {
        super(Application.getInstance().getUi(), true);
        initComponents();
        getRootPane().setDefaultButton(importB);
        setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,
                getParent().getY()+(getParent().getHeight()-getHeight())/2);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        mainFileF = new javax.swing.JTextField();
        mainFileB = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        repositoryFileF = new javax.swing.JTextField();
        repositoryFileB = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        importB = new javax.swing.JButton();
        stornoB = new javax.swing.JButton();

        FormListener formListener = new FormListener();

        setTitle("Import Old Format Files");
        addWindowListener(formListener);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        jPanel3.setLayout(new java.awt.GridLayout(2, 1, 4, 4));

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Main File of Test Specification: "));
        jPanel6.setLayout(new java.awt.BorderLayout(2, 2));

        mainFileF.setColumns(32);
        jPanel6.add(mainFileF, java.awt.BorderLayout.CENTER);

        mainFileB.setFont(new java.awt.Font("Dialog", 1, 14));
        mainFileB.setMnemonic('m');
        mainFileB.setText("...");
        mainFileB.setPreferredSize(new java.awt.Dimension(32, 22));
        mainFileB.addActionListener(formListener);

        jPanel6.add(mainFileB, java.awt.BorderLayout.EAST);

        jPanel4.add(jPanel6, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel4);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Case Set File of Test Specification:"));
        jPanel7.setLayout(new java.awt.BorderLayout(2, 2));

        repositoryFileF.setColumns(32);
        jPanel7.add(repositoryFileF, java.awt.BorderLayout.CENTER);

        repositoryFileB.setFont(new java.awt.Font("Dialog", 1, 14));
        repositoryFileB.setMnemonic('c');
        repositoryFileB.setText("...");
        repositoryFileB.setPreferredSize(new java.awt.Dimension(32, 22));
        repositoryFileB.addActionListener(formListener);

        jPanel7.add(repositoryFileB, java.awt.BorderLayout.EAST);

        jPanel5.add(jPanel7, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel5);

        jPanel1.add(jPanel3, java.awt.BorderLayout.NORTH);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 20, 5));

        importB.setMnemonic('i');
        importB.setText("Import");
        importB.addActionListener(formListener);

        jPanel2.add(importB);

        stornoB.setText("Close");
        stornoB.addActionListener(formListener);

        jPanel2.add(stornoB);

        jPanel1.add(jPanel2, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener, java.awt.event.WindowListener {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == mainFileB) {
                TwoFilesDialog.this.mainFileBActionPerformed(evt);
            }
            else if (evt.getSource() == repositoryFileB) {
                TwoFilesDialog.this.repositoryFileBActionPerformed(evt);
            }
            else if (evt.getSource() == importB) {
                TwoFilesDialog.this.importBActionPerformed(evt);
            }
            else if (evt.getSource() == stornoB) {
                TwoFilesDialog.this.stornoBActionPerformed(evt);
            }
        }

        public void windowActivated(java.awt.event.WindowEvent evt) {
        }

        public void windowClosed(java.awt.event.WindowEvent evt) {
        }

        public void windowClosing(java.awt.event.WindowEvent evt) {
            if (evt.getSource() == TwoFilesDialog.this) {
                TwoFilesDialog.this.closeDialog(evt);
            }
        }

        public void windowDeactivated(java.awt.event.WindowEvent evt) {
        }

        public void windowDeiconified(java.awt.event.WindowEvent evt) {
        }

        public void windowIconified(java.awt.event.WindowEvent evt) {
        }

        public void windowOpened(java.awt.event.WindowEvent evt) {
        }
    }// </editor-fold>//GEN-END:initComponents
    
    private void stornoBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stornoBActionPerformed
        // Add your handling code here:
        state=false;
        closeDialog(null);
    }//GEN-LAST:event_stornoBActionPerformed
    
    private void importBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importBActionPerformed
        // Add your handling code here:
        state=true;
        if (mainFileF.getText().length() == 0)
            main=null;
        else
            main=new File(mainFileF.getText());
        if (repositoryFileF.getText().length() == 0)
            repository=null;
        else
            repository=new File(repositoryFileF.getText());
        if (main == null || repository == null) {
            state=false;
            setModal(false);
            JOptionPane.showMessageDialog(getParent(),
                    "You have not specified "+((main == null)?"test spec":"case set")+" file.", "Warrning!", JOptionPane.WARNING_MESSAGE);
            setModal(true);
            return;
        }
        if (main.getAbsolutePath().equals(repository.getAbsolutePath())) {
            state=false;
            setModal(false);
            JOptionPane.showMessageDialog(getParent(),
                    "You cannot store both documents into one file!", "Warrning!", JOptionPane.WARNING_MESSAGE);
            setModal(true);
            return;
        }
        closeDialog(null);
    }//GEN-LAST:event_importBActionPerformed
    
    private void repositoryFileBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repositoryFileBActionPerformed
        // Add your handling code here:
        String s=FileUtil.openFileDialog(true, "Open CaseSet File", false, new String[] {"xml"}, "XML");
        if (s != null) {
            if (!s.toLowerCase().endsWith(".xml")) {
                s=s+".xml";
            }
            repositoryFileF.setText(s);
        }
    }//GEN-LAST:event_repositoryFileBActionPerformed
    
    private void mainFileBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mainFileBActionPerformed
        // Add your handling code here:
        String s=FileUtil.openFileDialog(true, "Open TestSpec File", false, new String[] {"xml"}, "XML");
        if (s != null) {
            if (!s.toLowerCase().endsWith(".xml")) {
                s=s+".xml";
            }
            mainFileF.setText(s);
        }
    }//GEN-LAST:event_mainFileBActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    public boolean getState() {
        return state;
    }
    
    public File getMainFile() {
        return main;
    }
    
    public File getRepositoryFile() {
        return repository;
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton importB;
    public javax.swing.JPanel jPanel1;
    public javax.swing.JPanel jPanel2;
    public javax.swing.JPanel jPanel3;
    public javax.swing.JPanel jPanel4;
    public javax.swing.JPanel jPanel5;
    public javax.swing.JPanel jPanel6;
    public javax.swing.JPanel jPanel7;
    public javax.swing.JButton mainFileB;
    public javax.swing.JTextField mainFileF;
    public javax.swing.JButton repositoryFileB;
    public javax.swing.JTextField repositoryFileF;
    public javax.swing.JButton stornoB;
    // End of variables declaration//GEN-END:variables
    
}
