/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.tree;


import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import org.netbeans.testspeceditor.beans.TestSpec;
import org.netbeans.testspeceditor.events.Bean;

/**
 *
 * @author ehucka
 */
public class TSTreeModel extends AbstractTreeModel {
    
    TreeSelectionModel selectionModel=null;
    
     
    public TSTreeModel() {
        super();
    }
    
    public void setSelectionModel(TreeSelectionModel selectionModel) {
        this.selectionModel=selectionModel;
    }
    
    public void setRoot(Bean spec) {
        root=new TestSpecNode((TestSpec)spec, this);
        treeStructureChanged(new TreeModelEvent(this, new Object[] {root}));
    }
    
    public void treeStructureChanged(TreeModelEvent e) {
        Object sel=null, ev=null;
        boolean preserve=false;
        TreePath path=selectionModel.getSelectionPath();
        if (path != null) {
            sel=path.getLastPathComponent();
            Object[] objs=e.getChildren();
            if (objs != null && objs.length > 0) {
                ev=objs[objs.length-1];
                if (ev != null && sel != null && sel == ev) {
                    preserve=true;  //preserve selection
                }
            }
        }
        TreeModelListener[] lss=listeners.toArray(new TreeModelListener[listeners.size()]);
        for (TreeModelListener lst:lss) {
            lst.treeStructureChanged(e);
        }
        
        if (preserve)
            selectionModel.setSelectionPath(path);
    }
}
