/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.quiz.entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.netbeans.modules.quiz.PersistenceUtils;

/**
 *
 * @author Jindrich Sedek
 */
@Entity
@Table(name = "USERDIR_LOGGING")
@NamedQueries({@NamedQuery(name = "UserdirLogging.findByOldNbid", query = "SELECT u FROM UserdirLogging u WHERE u.oldNbid = :oldNbid"),
@NamedQuery(name = "UserdirLogging.findByWhenChanged", query = "SELECT u FROM UserdirLogging u WHERE u.whenChanged = :whenChanged"), 
@NamedQuery(name = "UserdirLogging.findByEmail", query = "SELECT u FROM UserdirLogging u WHERE u.email = :email")})

public class UserdirLogging implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Column(name = "ID", nullable = false)
    private Integer id;
    @Column(name = "OLD_NBID", nullable = false)
    private String oldNbid;
    @Column(name = "WHEN_CHANGED")
    @Temporal(TemporalType.TIMESTAMP)
    private Date whenChanged;
    @Column(name = "EMAIL")
    private String email;

    public UserdirLogging() {
    }

    public UserdirLogging(String oldNbid, Date whenChanged, String email) {
        this.id = PersistenceUtils.getNextId(UserdirLogging.class);
        this.oldNbid = oldNbid;
        this.whenChanged = whenChanged;
        this.email = email;
    }

    public String getOldNbid() {
        return oldNbid;
    }

    public void setOldNbid(String oldNbid) {
        this.oldNbid = oldNbid;
    }

    public Date getWhenChanged() {
        return whenChanged;
    }

    public void setWhenChanged(Date whenChanged) {
        this.whenChanged = whenChanged;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (oldNbid != null ? oldNbid.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof UserdirLogging)) {
            return false;
        }
        UserdirLogging other = (UserdirLogging) object;
        if ((this.oldNbid == null && other.oldNbid != null) || (this.oldNbid != null && !this.oldNbid.equals(other.oldNbid))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.netbeans.modules.quiz.entities.UserdirLogging[oldNbid=" + oldNbid + "]";
    }

    /**
     * @return the id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Integer id) {
        this.id = id;
    }

}
