/*
                    Sun Public License Notice
 
The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/
 
The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.
 
Contributor(s): Petr Slegr.
 */

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import org.netbeans.modules.regsup.logic.*;
import java.awt.Point;

/** Adds new empty VisualAutomatonContainer into current VisualAutomatonContainer.
 *
 * @author  Petr Slegr
 */
// !!! nyni by nemusela byt subclass ElementAction
public class AddFromTemplateAction extends ElementAction implements AddAction {
    
    public void performAction (VisualAutomatonElement[] selected) {
        // version where current container (open) is treated as selected element
        /*
        VisualAutomatonContainer container = (VisualAutomatonContainer) selected [0];
        AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
        container.createContainer (editor.getCurrentPosition ());
         */
        AutomatonEditorPanel editorPanel = MainManager.getDefault ().getCurrentPanel ();
        if (editorPanel != null) {
            VisualAutomatonContainer container = editorPanel.getCurrentView ().getContainer ();
            AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
            container.createContainer (editor.getCurrentPosition ());
        }
    }
    
    public String getName () {
        return "Add Automaton From Template...";
        //return NbBundle.getMessage (AddExpressionAction.class, "CTL_ADD_EXPRESSION_ACTION");
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    
    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        if (selected.length != 0) {
            return false;
        }
        // !!! testovat umistitelnost
        // !!! zatim tehdy neni-li vybran zadny element
        //return true;
        return false;
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
