/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import org.netbeans.modules.regsup.logic.*;
import org.netbeans.modules.regsup.util.Util;
import org.netbeans.modules.regsup.debug.RexDebugger;

/**
 *
 * @author  Petr Slegr
 * @version 03.04.02
 */
public class StepAction extends CallableSystemAction implements DebuggingAction {
    
    public void performAction () {
        RexDebugger debugger = MainManager.getDefault ().getCurrentDebugger ();
        debugger.step ();
    }
    
    public String getName () {
        return "Step";
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /**
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        /*
        boolean b1 = selected.length == 1 && selected[0] instanceof VisualAutomatonNode;
        if (! b1) {
            return false;
        }
        VisualAutomatonNode node = (VisualAutomatonNode) selected[0];
        boolean b2 = MainManager.getDefault ().getCurrentDebugger ().containsActive (node);
        return b2;
         */
        return MainManager.getDefault ().getCurrentDebugger ().getCurrentState ().
        containsPureNodesOnly ();
    }
    
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
