/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import javax.swing.undo.CannotUndoException;

/** Action that can always be invoked and work procedurally.
 *
 * @author  Petr Slegr
 */
public class UndoAction extends CallableSystemAction {
    
    protected UndoAction () {
        super ();
    }
    
    public void performAction () {
        /*
        MainManager.getDefault ().getCurrentEditor ().getUndoManager ().undo ();
         */
        VisualAutomatonContainer container = (VisualAutomatonContainer) MainManager.
        getDefault ().getSelectedElements ()[0];
        AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
        try {
            editor.getUndoManager ().undo ();
        }
        catch (CannotUndoException ex) {
            throw new IllegalStateException (ex.toString () + ex.getMessage ());
        }
        
    }
    
    public String getName () {
        if (! isEnabled ()) {
            return "Undo";  // !! bundle
        } else {
            /*
            //System.out.println("undo name: " + MainManager.getDefault ().getCurrentEditor ().getUndoManager ().
            //getUndoPresentationName ());
            return MainManager.getDefault ().getCurrentEditor ().getUndoManager ().
            getUndoPresentationName ();
             */
            // nove
            /*
            VisualAutomatonContainer container = (VisualAutomatonContainer) 
            MainManager.getDefault ().getSelectedElements ()[0];
            AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
            return editor.getUndoManager ().getUndoPresentationName ();
             */
            return MainManager.getDefault ().getCurrentPanel ().getRootEditor ().getUndoManager ().getUndoPresentationName ();
        }
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled () {
        /*
        VisualAutomatonElement[] selected = MainManager.getDefault ().getSelectedElements ();
        boolean b1 = selected.length == 1;
        boolean b2 = selected[0] instanceof VisualAutomatonContainer;
        if (! b1 || ! b2) {
            return false;
        }
        VisualAutomatonContainer container = (VisualAutomatonContainer) selected[0];
        AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
        return editor.getUndoManager ().canUndo ();
         */
        // !!! hrozi NPE
        AutomatonEditorPanel panel = MainManager.getDefault ().getCurrentPanel ();
        if (panel == null) {
            return false;
        }
        return panel.getRootEditor ().getUndoManager ().canUndo ();
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
