package org.netbeans.modules.regsup.debug;

import org.netbeans.modules.regsup.logic.*;
import java.util.ArrayList;

/**
 *
 * @author  Petr Slegr
 * @version 03.01.02
 */
class NodePath {

    private ArrayList path;
    
    /** Creates new NodePath */
    private NodePath () {
        path = new ArrayList ();
    }
    
    public NodePath (LogicAutomatonNode node) {
        this ();
        add (node);
    }
    
    /**
     */
    public NodePath (NodePath previous) {
        this ();
        try {
            path = (ArrayList) previous.clone ();
        }
        catch (CloneNotSupportedException exc) {
            exc.printStackTrace ();
        }
    }

    /*
    public NodePath (NodePath previous, LogicAutomatonNode node, boolean replace) {
        this (previous);
        if (replace) {
            path.remove (previous.path.size () - 1);
        }
        path.add (node);
    }
     */
    
    /** Adds node to the path.
     */
    public void add (LogicAutomatonNode node) {
       boolean res = path.add (node);
        if (! res) {
            throw new IllegalStateException ("Trying to add node second time: " + node);
        }
    }
    
    /**
     */
    public LogicAutomatonNode get (int index) {
        return (LogicAutomatonNode) path.get (index);
    }
    
    /**
     */
    public LogicAutomatonNode getLast () {
        return (LogicAutomatonNode) path.get (path.size () - 1);
    }

    /**
     */
    public void removeLast () {
        path.remove (path.size () - 1);
    }
    
    /**
     */
    public int size () {
        return path.size ();
    }
}
