/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

import java.util.*;

/**
 *
 * @author  Petr Slegr
 * @version 01.05.02/2
 */
public class LogicAutomatonEdge {
    
    private RexEdgeElement value;
    
    private final LogicAutomatonNode source;
    
    private final LogicAutomatonNode target;
    
    /** Creates new LogicAutomatonEdge.
     * It is called by LogicAutomatonNode.addXXXEdge
     */
    LogicAutomatonEdge (
            LogicAutomatonNode source,
            LogicAutomatonNode target,
            RexEdgeElement value) {
        this.source = source;
        this.target = target;
        this.value = value;
    }
    
    /** Creates "self-edge"
     */
    LogicAutomatonEdge (LogicAutomatonNode source, RexEdgeElement value) {
        this (source, source, value);
    }
    
    /**
     * @return null when edge exists
     */
    /*
    public static LogicAutomatonEdge create (
    LogicAutomatonNode source,
    LogicAutomatonNode target,
    RexEdgeElement rex) {
        LogicAutomatonEdge edge = new LogicAutomatonEdge (source, target, rex);
        if (! source.containsNextEdge (edge) && ! target.containsPrevEdge (edge)) {
            source.addNext (edge);
            target.addPrev (edge);
        }
        else
            edge = null;
        return edge;
    }
     */
    
    /*
    public void remove () {
        source.removeNext (this);
        target.removePrev (this);
    }
     */
    
    /**
     */
    public LogicAutomatonNode getSource () {
        return source;
    }
    
    /**
     */
    public LogicAutomatonNode getTarget () {
        return target;
    }
    
    /**
     */
    public RexEdgeElement getEdgeValue () {
        return value;
    }
    
    public void setEdgeValue (RexEdgeElement edgeValue) {
        value = edgeValue;
        source.checkDetermin (this); // ! was bug: after value change determinism have to be check
    }
    
    /**
     */
    public String toString () {
        return new String ("LogicEdge: " + source + "," + target + "," + value);
    }
    
    public static Set outputEdges2Nodes (Set edges) {
        Iterator it = edges.iterator ();
        Set res = new HashSet ();
        while (it.hasNext ()) {
            res.add (((LogicAutomatonEdge) it.next ()).getTarget ());
        }
        return res;
    }
    
    public static void main (String[] args) {
        /*
        //
        LogicAutomatonEdge edge = new LogicAutomatonEdge (
            new LogicAutomatonNode (), 
            new LogicAutomatonNode (), 
            RexEdgeElement.createSingle ('a')
        );
        System.out.println("edge: " + edge);
        //
        LogicAutomatonNode node1 = new LogicAutomatonNode ();
        LogicAutomatonNode node2 = new LogicAutomatonNode ();
        node1.addOuptputEdge (node2, RexEdgeElement.createSingle ('b'));
        System.out.println("node1: " + node1);
        System.out.println("node1's out: " + node1.getOutputEdges ());
        System.out.println("node1's in: " + node1.getInputEdges ());
        System.out.println("node2: " + node2);
        System.out.println("node2's out: " + node2.getOutputEdges ());
        System.out.println("node2's in: " + node2.getInputEdges ());
        //node1.addOuptputEdge (node2, RexEdgeElement.createSingle ('b'));
        node2.addInputEdge (node1, RexEdgeElement.createSingle ('b'));
         */
    }
}
