/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.vcs.cmdline.commands;

import java.util.*;
import javax.swing.table.*;
import javax.swing.*;

import org.openide.*;

import org.netbeans.modules.vcscore.*;
import org.netbeans.modules.vcscore.util.*;
import org.netbeans.modules.vcs.cmdline.*;


/**
 *
 * @author  Martin Entlicher
 */
public class CvsModuleSelectorDialog extends javax.swing.JPanel {

    private Vector modules = null;
    //private volatile InformationDialog waitDlg = null;
    private javax.swing.ButtonGroup bg;
    private CvsModuleSelector model;
    private String[] args;

    private static HashMap cash = new HashMap ();

    static final long serialVersionUID = 1987612235843595460L;
    /** Creates new form CvsModuleSelectorDialog */
    public CvsModuleSelectorDialog(CvsModuleSelector model, String[] args) {
        super ();
        this.model = model;
        this.args = args;
        initComponents ();
        tblModules.getTableHeader().setReorderingAllowed(true);
        javax.swing.ButtonGroup bg = new javax.swing.ButtonGroup ();
        bg.add (rbCheckoutModule);
        bg.add (rbIgnore);
        initData();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        statusLabel = new javax.swing.JLabel();
        listScrollPane = new javax.swing.JScrollPane();
        tblModules = new javax.swing.JTable();
        lblWarning = new javax.swing.JLabel();
        lblOptions = new javax.swing.JLabel();
        rbCheckoutModule = new javax.swing.JRadioButton();
        rbIgnore = new javax.swing.JRadioButton();
        refresh = new javax.swing.JButton();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        statusLabel.setText("kuk");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(statusLabel, gridBagConstraints1);
        
        tblModules.setShowVerticalLines(false);
        tblModules.setPreferredScrollableViewportSize(new java.awt.Dimension(300, 200));
        tblModules.setShowHorizontalLines(false);
        listScrollPane.setViewportView(tblModules);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 12, 12);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(listScrollPane, gridBagConstraints1);
        
        lblWarning.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("CvsModuleSelectorDialog.lbWarning.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblWarning, gridBagConstraints1);
        
        lblOptions.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("CvsModuleSelectorDialog.lblOptions.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblOptions, gridBagConstraints1);
        
        rbCheckoutModule.setSelected(true);
        rbCheckoutModule.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("CvsModuleSelectorDialog.rbCheckoutModule.text"));
        rbCheckoutModule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbCheckoutModuleActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbCheckoutModule, gridBagConstraints1);
        
        rbIgnore.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("CvsModuleSelectorDialog.rbIgnore.text"));
        rbIgnore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbIgnoreActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbIgnore, gridBagConstraints1);
        
        refresh.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/commands/Bundle").getString("CvsModuleSelectorDialog.refresh"));
        refresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshModules(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 6, 12);
        add(refresh, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void refreshModules(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshModules
        // Add your handling code here:
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new Thread("ModuleSelector-Command") {
                    public void run() {
                        waitingForModules();
                        Vector modules = CvsModuleSelectorDialog.this.model.getModulesList (CvsModuleSelectorDialog.this.args);
                        boolean cmdSuccess = (modules != null);
                        VcsFileSystem fs = CvsModuleSelectorDialog.this.model.getFileSystem();
                        if (fs instanceof CvsFileSystem) {
                            CvsFileSystem cvsFs = (CvsFileSystem)fs;
                            String key = ":"+cvsFs.getCvsServerType()+":"+cvsFs.getCvsUserName()+"@"+cvsFs.getCvsServer()+":"+cvsFs.getCvsRoot();
                            cash.put (key, modules);
                        }
                        setModules(modules, cmdSuccess);    
                   }
                }.start();
            }
        });
    }//GEN-LAST:event_refreshModules

  private void rbIgnoreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbIgnoreActionPerformed
// Add your handling code here:
      tblModules.setEnabled(false);
      tblModules.getSelectionModel().clearSelection();
  }//GEN-LAST:event_rbIgnoreActionPerformed

  private void rbCheckoutModuleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbCheckoutModuleActionPerformed
// Add your handling code here:
      tblModules.setEnabled(true);
  }//GEN-LAST:event_rbCheckoutModuleActionPerformed


    
    public void calledAsCommand(boolean yeah) {
      if (yeah) {
          lblWarning.setVisible(false);
          lblOptions.setVisible(false);
          rbCheckoutModule.setVisible(false);
          rbIgnore.setVisible(false);
      } else {
          lblWarning.setVisible(true);
          lblOptions.setVisible(true);
          rbCheckoutModule.setVisible(true);
          rbIgnore.setVisible(true);
      }      
    }    

    public void waitingForModules() {
        statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.waitingForModules"));
        /*
        if (waitDlg == null) {
          javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
              waitDlg = new InformationDialog(new java.awt.Frame(), true, "Please wait, modules are loading ...");
              MiscStuff.centerWindow(waitDlg);
              waitDlg.show();
            }
          });
    }
        */
    }

    /*
     * This method picks good column sizes.
     * If all column heads are wider than the column's cells' 
     * contents, then you can just use column.sizeWidthToFit().
     *
    private void initColumnSizes(JTable table, TableModel model) {
        TableColumn column = null;
        java.awt.Component comp = null;
        int headerWidth = 0;
        int cellWidth = 0;
        int columns = model.getColumnCount();
        
        for (int i = 0; i < columns; i++) {
            column = table.getColumnModel().getColumn(i);

            comp = column.getHeaderRenderer().
                             getTableCellRendererComponent(
                                 null, column.getHeaderValue(), 
                                 false, false, 0, 0);
            headerWidth = comp.getPreferredSize().width;
            /*
            comp = table.getDefaultRenderer(model.getColumnClass(i)).
                             getTableCellRendererComponent(
                                 table, model.getValueAt(, i),
                                 false, false, 0, i);
            cellWidth = comp.getPreferredSize().width;
            *
            column.setPreferredWidth(headerWidth); //Math.max(headerWidth, cellWidth));
        }
    }
     */

    public void setModules(Vector modules, boolean success) {
        this.modules = modules;
        //if (waitDlg != null) waitDlg.setVisible(false);
        if (success) statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.modulesLoaded"));
        else statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.modulesLoadError"));
        if (modules == null || modules.size() == 0) {
            javax.swing.SwingUtilities.invokeLater(new Runnable() {
                                                       public void run() {
                                                           NotifyDescriptor nd = new NotifyDescriptor.Message (org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.noModules"));
                                                           TopManager.getDefault ().notify (nd);
                                                       }
                                                   });
              rbCheckoutModule.setEnabled(false);                                      
         //   closeDialog(null);
        } else {
            Vector columns = new Vector();
            columns.add(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.columnModule"));
            columns.add(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.columnStatus"));
            DefaultTableModel model = new MyDefaultTableModel(modules, columns);
            TableSorter sorter = new TableSorter(model);
            tblModules.setModel(sorter);
            //tblModules.createDefaultColumnsFromModel();
            //initColumnSizes(tblModules, model);
            sorter.addMouseListenerToHeaderInTable(tblModules);
            sorter.sortByColumn(0, true); 
            //tblModules.revalidate();
            //tblModules.repaint();
            listScrollPane.validate();
            //pack();
        }
    }

    public String[] getSelection() {
        if (tblModules.getSelectedRowCount() == 0) {return null;}
        int[] select = tblModules.getSelectedRows();
        TableModel model = tblModules.getModel();
        Vector selStr = new Vector();
        for (int ind = 0; ind < select.length; ind++) {
            String mod = (String)model.getValueAt(select[ind], 0);
            selStr.add(mod);
        }    
        String[] modulesStrs = (String[]) selStr.toArray(new String[0]);
        return modulesStrs;
    }
    
    private void initData () {
        Vector modules = null;
        VcsFileSystem fs = this.model.getFileSystem();
        if (fs instanceof CvsFileSystem) {
            CvsFileSystem cvsFs = (CvsFileSystem)fs;
            String key = ":"+cvsFs.getCvsServerType()+":"+cvsFs.getCvsUserName()+"@"+cvsFs.getCvsServer()+":"+cvsFs.getCvsRoot();
            modules = (Vector) cash.get (key);
        }
        if (modules == null) {
            this.refreshModules (null);
        }
        else {
            setModules (modules,true);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel statusLabel;
    private javax.swing.JScrollPane listScrollPane;
    private javax.swing.JTable tblModules;
    private javax.swing.JLabel lblWarning;
    private javax.swing.JLabel lblOptions;
    private javax.swing.JRadioButton rbCheckoutModule;
    private javax.swing.JRadioButton rbIgnore;
    private javax.swing.JButton refresh;
    // End of variables declaration//GEN-END:variables
   
   class MyDefaultTableModel extends DefaultTableModel {
       
       static final long serialVersionUID = 4907156662613927521L;       

      public MyDefaultTableModel (Vector data, Vector columns) {
        super(data, columns);   
      }    
           
      public boolean isCellEditable(int row, int column) {
        return false;  
      }    
 
   }    
    
}

